package cn.com.ctop.job.kuaishou.handler;


import cn.com.ctop.job.kuaishou.utils.DateUtils;
import cn.com.ctop.job.kuaishou.utils.HttpUtils;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * 供应链-快分销数据
 */
@Component
public class CheckSupplyChainJob {

    @XxlJob("checkSupplyChainJob")
    public void execute() throws Exception {
        try {
            String today = DateUtils.getNowDateStr();
            //昨天
            String yesterday = DateUtils.getLastDay(today, 1);
            Map<String, Object> paramMap = new HashMap<String, Object>();
            paramMap.put("endDate", today);
            paramMap.put("beginDate", yesterday);
            HttpUtils.httpGet("http://ruixuan.api.tjyourong.com.cn/isv/supply_chain/addList", paramMap, null);
            XxlJobHelper.log(" --------供应链-快分销数据，执行完成-------- " + paramMap.toString());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
