package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.utils.Check;
import cn.com.ctop.job.kuaishou.utils.HttpUtils;
import com.alibaba.fastjson.JSONObject;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@Component
public class HostingCreateJob {
    @Autowired
    private CommonService commonService;

    /**
     * 智能托管
     */
    @XxlJob("createHosting")
    public void createHosting() {
        try {
            String url = "http://api.tjyourong.com.cn/jeecg-boot/task/kuaishouHostingTask/createHosting";
            List<Long> idList = commonService.getHostingIdList();
            if (Check.isNull(idList)) {
                log.error("没有待创建的智能托管定时任务");
                return;
            }
            for (int i = 0; i < idList.size(); i++) {
                Long tableId = idList.get(i);
                Map<String, Object> requestMap = new HashMap<>();
                requestMap.put("id", tableId);
                String s = HttpUtils.httpGet(url, requestMap, null);
                JSONObject result = JSONObject.parseObject(s);
                if (!Check.isNull(result)) {
                    if (result.getInteger("code") != 0) {
                        log.error("任务提交失败，id：{}", tableId);
                    }
                } else {
                    log.error("任务提交返回结果为空，id：{}", tableId);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
