package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.service.AccountInfoService;
import cn.com.ctop.job.kuaishou.utils.DateUtils;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class KuaiShouYesterdayAgentReportJob {
    @Autowired
    private AccountInfoService accountInfoService;

    /**
     * 代理商t-1数据获取
     */
    @XxlJob("kuaiShouYesterdayAgentReportJob")
    public void execute() {
        try {
            String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
            String endDate = DateUtils.getAnotherDay("yyyy-MM-dd", nowDate, -1);
            String startDate = DateUtils.getAnotherDay("yyyy-MM-dd", nowDate, -2);
            accountInfoService.getAgentReportByPage(startDate, endDate);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

