package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class KuaishouCampaignJob {
    @Autowired
    private CommonService commonService;
    @Autowired
    private TokenService tokenService;

    static ExecutorService executorService = Executors.newFixedThreadPool(5);

    /**
     * 快手全量计划物料数据
     */
    @XxlJob("kuaishouCampaignJob")
    public void execute() {
        try {
            List<CtopOauthToken> tokens = tokenService.getAllKuaiShouTokens();
            tokens.forEach(token -> executorService.submit(() -> commonService.getCampaignList(token, null, null)));
            XxlJobHelper.log("快手物料数据同步完成");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
