package cn.com.ctop.job.kuaishou.handler;


import cn.com.ctop.job.kuaishou.entity.UserAllocation;
import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import cn.com.ctop.job.kuaishou.utils.Check;
import cn.com.ctop.job.kuaishou.utils.DateUtils;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;



@Component
@Slf4j
public class KuaishouCleanNews {
    @Autowired
    private CommonService commonService;
    @Autowired
    private TokenService tokenService;

    static ExecutorService cleanService = Executors.newFixedThreadPool(15);

    @XxlJob("cleanNews")
    public void cleanNews() {
        try {
            String nowDate = DateUtils.getDate("yyyy-MM-dd");
            String statDate = DateUtils.getAnotherDay("yyyy-MM-dd", nowDate, -1);
            Date startDate = DateUtils.getStartDate(statDate);
            Date endDate = DateUtils.getEndDate(statDate);
            List<UserAllocation> userAllocations = commonService.listByMediaId("2", 0);
            if (!Check.isNull(userAllocations)) {
                for (UserAllocation allocation : userAllocations) {
                    cleanService.submit(new Runnable() {
                        @Override
                        public void run() {
                            try {
                                commonService.cleanCreateDetail(allocation.getProjectId(), allocation.getUserId(), allocation.getUserName(), allocation.getAccountId(), statDate, startDate, endDate);
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    });
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

