package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.utils.DateUtils;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * 账户维度-盯盘每日数据
 *
 * @author syh
 */
@Component
public class KuaishouDailyAccountReportLoadEtlJob {
    @Autowired
    private CommonService commonService;

    /**
     * 清洗账户维度-每日盯盘数据
     */
    @XxlJob("kuaishouDailyAccountReportLoadEtl")
    public void execute() {
        try {
            try {
                commonService.queryEveryDayDataForAccount();
                XxlJobHelper.log("queryEveryDayDataForAccount success");
            } catch (Exception e) {
                XxlJobHelper.log(e.getMessage());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 快手账户素材数据清洗任务
     */
    @XxlJob("etlKuaishouAccountMaterialReportDailyData")
    public void etlKuaishouAccountMaterialReportDailyData() {
        try {
            try {
                commonService.etlKuaishouAccountMaterialReportDailyData(DateUtils.formatDate());
                commonService.etlKuaishouAccountMaterialReportDailyData(DateUtils.formatDate(DateUtils.addDay(new Date(), -1)));
                XxlJobHelper.log("queryEveryDayDataForAccount success");
            } catch (Exception e) {
                XxlJobHelper.log(e.getMessage());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
