package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import cn.com.ctop.job.kuaishou.utils.DateUtils;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * 快手广告主分天数据
 *
 * @author syh
 */
@Component
public class KuaishouDailyAccountReportLoadJob {
    @Autowired
    private CommonService commonService;
    @Autowired
    private TokenService tokenService;

    static ExecutorService executorService = Executors.newFixedThreadPool(5);
    static ExecutorService adSceneExecutorService = Executors.newFixedThreadPool(5);

    /**
     * 快手广告主日报
     */
    @XxlJob("kuaishouDailyAccountReport")
    public void execute() {
        try {
            Date getDate = new Date();
            Date getDate2 = DateUtils.addDay(new Date(), -2);
            //1:查询当日数据
            List<CtopOauthToken> tokens = tokenService.getAllKuaiShouTokens();
            if (null == tokens || tokens.isEmpty()) {
                XxlJobHelper.log("定时获取快手数据异常：未获取到可用的token");
                XxlJobHelper.handleFail();
                return;
            }
            tokens.forEach(token -> executorService.submit(() -> {
                commonService.getAdvertiserReportDaily(token, getDate2, getDate, null);
            }));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 账户日报-分版位数据
     * @throws Exception
     */
    @XxlJob("kuaishouDailyAccountAdSceneReport")
    public void kuaishouDailyAccountAdSceneReport() {
        try {
            Date getDate = DateUtils.addDay(new Date(), -1);
            Date getDate2 = DateUtils.addDay(new Date(), -2);
            //1:查询当日数据
            List<CtopOauthToken> tokens = tokenService.getAllKuaiShouTokens();
            if (null == tokens || tokens.isEmpty()) {
                XxlJobHelper.log("定时获取快手数据异常：未获取到可用的token");
                XxlJobHelper.handleFail();
                return;
            }
            tokens.forEach(token -> adSceneExecutorService.submit(() -> {
                commonService.getAdvertiserReportDaily(token, getDate2, getDate, "adScene");
            }));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
