package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import cn.com.ctop.job.kuaishou.utils.DateUtils;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * 广告计划分天报表
 *
 * @author syh
 */
@Component
public class KuaishouDailyCampaignReportLoadJob {

    @Autowired
    private CommonService commonService;
    @Autowired
    private TokenService tokenService;

    static ExecutorService executorService = Executors.newFixedThreadPool(5);

    /**
     * 快手计划日报数据
     * @throws Exception
     */
    @XxlJob("kuaishouDailyCampaignReport")
    public void execute() {
        try {
            Date getDate = DateUtils.addDay(new Date(), -2);
            Date endDate = DateUtils.addDay(new Date(), -1);
            //1:查询当日数据
            List<CtopOauthToken> tokens = tokenService.getAllKuaiShouTokens();
            if (null == tokens || tokens.isEmpty()) {
                XxlJobHelper.log("定时获取快手数据异常：未获取到可用的token");
                XxlJobHelper.handleFail();
                return;
            }
            tokens.forEach(token -> executorService.submit(() -> commonService.getAdvertiserCampaignReportDaily(token, getDate, endDate)));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }




}
