package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import cn.com.ctop.job.kuaishou.utils.Check;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class KuaishouDailyFlowsJob {
    @Autowired
    private CommonService commonService;
    @Autowired
    private TokenService tokenService;
    /**
     * 快手账户流水信息
     */
    @XxlJob("kuaishouDailyFlowsJob")
    public void execute() {
        try {
            List<CtopOauthToken> tokens = tokenService.getAllKuaiShouTokens();
            if (!Check.isNull(tokens)) {
                for (CtopOauthToken ctopOauthToken : tokens) {
                    commonService.getDailyFlows(ctopOauthToken);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
