package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import cn.com.ctop.job.kuaishou.utils.DateUtils;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class KuaishouDingPanCleanJob {
    @Autowired
    private CommonService commonService;
    @Autowired
    private TokenService tokenService;

    static ExecutorService executorService = Executors.newFixedThreadPool(6);
    static ExecutorService materialExecutorService = Executors.newFixedThreadPool(6);

    /**
     * 快手盯盘每日上新数据
     */
    @XxlJob("cleanNewlyData")
    public void cleanNewlyData() {
        try {
            String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
            String yesterdayDate = DateUtils.getAnotherDay("yyyy-MM-dd", nowDate, -1);
            commonService.cleanNewlyData(yesterdayDate);
            XxlJobHelper.log("快手清洗上新计划数据完成");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
