package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.service.AccountInfoService;
import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import cn.com.ctop.job.kuaishou.utils.DateUtils;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class KuaishouGroupJob {
    @Autowired
    private AccountInfoService accountInfoService;
    @Autowired
    private TokenService tokenService;

    static ExecutorService executorService = Executors.newFixedThreadPool(3);

    /**
     * 快手广告组物料
     */
    @XxlJob("kuaishouGroup")
    public void execute() {
        try {
            Date endDate = new Date();
            String anotherDay = DateUtils.getAnotherDay("yyyy-MM-dd", DateUtils.formatDate(endDate), -1);
            SimpleDateFormat sim = new SimpleDateFormat("yyyy-MM-dd");
            Date parse = sim.parse(anotherDay);
            List<CtopOauthToken> tokens = tokenService.getAllKuaiShouTokens();
            tokens.forEach(token -> executorService.submit(() -> accountInfoService.getGroupList(token, parse, parse)));
            XxlJobHelper.log("快手物料数据同步完成");
        } catch (ParseException e) {
            e.printStackTrace();
        }
    }

}
