package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.service.AccountInfoService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * 账户维度-盯盘每小时数据
 *
 * @author syh
 */
@Component
public class KuaishouHourlyAccountReportLoadEtlJob {
    @Autowired
    private AccountInfoService accountInfoService;

    /**
     * 清洗账户维度-盯盘小时数据
     */
    @XxlJob("kuaishouHourlyAccountReportLoadEtl")
    public void execute() {
        try {
            accountInfoService.queryEveryhourlyDataForAccount();
            XxlJobHelper.log("queryEveryhourlyDataForAccount success");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
