package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.service.AccountInfoService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class KuaishouNowDateGroupJob {
    @Autowired
    private AccountInfoService accountInfoService;
    @Autowired
    private TokenService tokenService;
    static ExecutorService executorService = Executors.newFixedThreadPool(3);

    /**
     * 快手当日广告组物料数据
     */
    @XxlJob("kuaishouNowDateGroup")
    public void execute()  {
        try {
            //查询当日数据
            Date nowDate = new Date();
            List<CtopOauthToken> tokens = tokenService.getAllKuaiShouTokens();
            tokens.forEach(token -> executorService.submit(() -> accountInfoService.getGroupList(token, nowDate, nowDate)));
            XxlJobHelper.log("快手物料数据同步完成");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
