package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.service.AccountInfoService;
import cn.com.ctop.job.kuaishou.service.UserService;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
@Slf4j
public class NewMonitorOneDayJob {
    @Autowired
    private UserService userService;
    @Autowired
    private AccountInfoService accountInfoService;

    /**
     * 账户清理
     *
     * @author ZZY
     */
    @XxlJob("synchronousMonitorOneDay")
    public void execute() {
        try {
            try {
                List<Long> kuaiShouallAccountId = userService.getAccountIdsByMedia("2");
                List<Long> touTiaoAccountId = userService.getAccountIdsByMedia("1");
                for (Long aLong : kuaiShouallAccountId) {
                    accountInfoService.synchronousKuaiShouMonitor("1", aLong);
                }
                for (Long aLong : touTiaoAccountId) {
                    accountInfoService.synchronousTouTiaoMonitor("1", aLong);
                }
            } catch (Exception e) {
                log.info("清理完成完成");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
