package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class RuleKuaiShouDataAccountCleanJob {

    @Autowired
    private CommonService commonService;

    @Autowired
    private TokenService tokenService;

    private ExecutorService executorService = Executors.newFixedThreadPool(3);

    /**
     * 快手规则引擎账户数据
     *
     * @throws Exception
     */
    @XxlJob("ruleKuaiShouDataAccountCleanJob")
    public void execute() {
        try {
            XxlJobHelper.log("规则预警账户维度数据开始清洗");
            List<CtopOauthToken> tokens = tokenService.queryKsValidRuleAccountsToken();
            tokens.forEach(token -> executorService.submit(() -> {
                commonService.deleteRuleAccountId(token.getAccountId());
                commonService.cleanRuleDataAccount(token.getAccountId());
            }));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
