package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class RuleKuaiShouDataPlanCleanJob {
    @Autowired
    private CommonService commonService;

    @Autowired
    private TokenService tokenService;

    private ExecutorService executorService = Executors.newFixedThreadPool(3);

    /**
     * 快手规则引擎计划数据
     */
    @XxlJob("ruleKuaiShouDataPlanCleanJob")
    public void execute() {
        try {
            XxlJobHelper.log("规则预警计划维度数据开始清洗");
            List<CtopOauthToken> tokens = tokenService.queryKsValidRuleAccountsToken();
            tokens.forEach(token -> executorService.submit(() -> {
                commonService.deleteRulePlan(token.getAccountId());
                commonService.cleanRuleDataPlan(token.getAccountId(), 1);
            }));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
