package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import cn.com.ctop.job.kuaishou.utils.DateUtils;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class RuleKuaiShouDataUnitCleanJob {
    @Autowired
    private CommonService commonService;

    @Autowired
    private TokenService tokenService;

    private ExecutorService executorService = Executors.newFixedThreadPool(10);

    /**
     * 快手规则引擎组维度数据
     *
     * @throws Exception
     */
    @XxlJob("ruleKuaiShouDataUnitCleanJob")
    public void execute() {
        try {
            XxlJobHelper.log("规则预警组维度数据开始清洗");
            List<CtopOauthToken> tokens = tokenService.queryKsValidRuleAccountsToken();
            tokens.forEach(token -> executorService.submit(() -> {
                commonService.deleteRuleUnit(token.getAccountId());
                commonService.cleanRuleDataUnit(token.getAccountId(), token.getAccessToken(), DateUtils.date2Str(), DateUtils.date2Str(), 1);
            }));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
