package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import cn.com.ctop.job.kuaishou.utils.Check;
import cn.com.ctop.job.kuaishou.utils.HttpUtils;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
public class TrackWarningJob {

    @Autowired
    private CommonService commonService;
    @Autowired
    private TokenService tokenService;

    /**
     * 自定义创建监测链接预警
     */
    @XxlJob("monitorCreative")
    public void monitorCreative() {
        try {
            String url = "http://api.tjyourong.com.cn/jeecg-boot/monitor/trackMonitorLogs/monitorCreative";
            System.err.println("请求地址为:" + url);
            List<Long> idList = commonService.getAccountIds();
            if (Check.isNull(idList)) {
                XxlJobHelper.log("自定义创意监测链接预警");
                return;
            }
            for (int i = 0; i < idList.size(); i++) {
                Long id = idList.get(i);
                Map<String, Object> requestMap = new HashMap<>();
                requestMap.put("accountId", id);
                HttpUtils.httpGet(url, requestMap, null);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 程序化监测链接预警
     */
    @XxlJob("monitorProgramCreative")
    public void monitorProgramCreative() {
        try {
            String url = "http://api.tjyourong.com.cn/jeecg-boot/monitor/trackMonitorLogs/monitorProgramCreative";
//            System.out.println("请求地址为:" + url);
            List<Long> idList = commonService.getAccountIds();
            if (Check.isNull(idList)) {
                XxlJobHelper.log("自定义创意监测链接预警");
                return;
            }
            for (int i = 0; i < idList.size(); i++) {
                Long id = idList.get(i);
                Map<String, Object> requestMap = new HashMap<>();
                requestMap.put("accountId", id);
                HttpUtils.httpGet(url, requestMap, null);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
