package cn.com.ctop.job.kuaishou.mapper;

import cn.com.ctop.job.kuaishou.entity.EtlKuaishouReportAccountHourly;
import cn.com.ctop.job.kuaishou.entity.KuaiShouAppInfo;
import cn.com.ctop.job.kuaishou.entity.KuaiShouCampaign;
import cn.com.ctop.job.kuaishou.entity.KuaiShouDailyAgent;
import cn.com.ctop.job.kuaishou.entity.KuaiShouGroup;
import cn.com.ctop.job.kuaishou.entity.KuaiShouGroupTarget;
import cn.com.ctop.job.kuaishou.entity.KuaiShouSchedule;
import cn.com.ctop.job.kuaishou.entity.KuaishouReportHourlyAccount;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

public interface AccountInfoMapper {

    void deleteUnitById(@Param("accountId") Long accountId, @Param("unitId") Long unitId);

    void replaceBatchGroup(@Param(value = "groups") List<KuaiShouGroup> groups);

    void replaceBatchShouSchedule(@Param(value = "schedules") List<KuaiShouSchedule> shouSchedules);

    void replaceBatchAppInfo(@Param(value = "appInfos") List<KuaiShouAppInfo> appInfos);

    void replaceBatchGroupTarget(@Param("targets") List<KuaiShouGroupTarget> targets);

    List<EtlKuaishouReportAccountHourly> queryEveryhourlyDataForAccount();

    void replaceBatchEtlHourlyAccount(@Param("list") List<EtlKuaishouReportAccountHourly> list);

    void replaceBatchEtlDailyAccount(@Param("list") List<EtlKuaishouReportAccountHourly> list);

    void replaceBatchKuaishouReportHourlyAccount(@Param("addList") List<KuaishouReportHourlyAccount> addList);

    Integer selectMaxHour(@Param("accountId") Long accountId, @Param("statDate") String statDate);

    BigDecimal getkuaishouReportHourlyCost(@Param("accountId") Long accountId, @Param("statHour") Integer statHour, @Param("statDate") String statDate);

    void replaceBatchKuaiShouDailyAgent(@Param(value = "list") List<KuaiShouDailyAgent> list);

    List<Map> getKuaiShouGroup(@Param("date") String date, @Param("accountId") String accountId);

    List<Map> getKuaiShouGroupNow(@Param("date") String date, @Param("accountId") String accountId);

    BigDecimal getGroupCharge(@Param("unitId") String unitId, @Param("afterDate") String afterDate);

    String getMonitorGroupByUnitId(@Param("unitId") String unitId);

    void updateMonitorGroupByUnitId(@Param("unitId") String unitId, @Param("effective") String effective);

    void saveMonitorGroup(@Param("accountId") String accountId, @Param("accountName") String accountName, @Param("operatingName") String operatingName, @Param("unitId") String unitId, @Param("createTime") String createTime, @Param("projectType") String projectType, @Param("effective") String effective);

    List<Map> getKuaiShouCampaign(@Param("date") String date, @Param("accountId") String accountId);

    List<Map> getKuaiShouCampaignNow(@Param("date") String date, @Param("accountId") String accountId);

    BigDecimal getCampaignCharge(@Param("campaignId") String campaignId, @Param("afterDate") String afterDate);

    String getMonitorPlanByCampaignId(@Param("campaignId") String campaignId);

    void updateMonitorPlanByCampaignId(@Param("campaignId") String campaignId, @Param("effective") String effective);

    void saveMonitorCampaign(@Param("accountId") String accountId, @Param("accountName") String accountName, @Param("operatingName") String operatingName, @Param("campaignId") String campaignId, @Param("createTime") String createTime, @Param("projectType") String projectType, @Param("effective") String effective);

    List<Map> getTouTiaoCampaign(@Param("date") String date, @Param("accountId") String accountId);

    List<Map> getTouTiaoCampaignNow(@Param("date") String date, @Param("accountId") String accountId);

    BigDecimal getCampaignChargeTouTiao(@Param("campaignId") String campaignId, @Param("afterDate") String afterDate);

    List<KuaiShouCampaign> getCampaignByAccountId(@Param("accountId") Long accountId);

    KuaiShouGroup getGroupOneByUnitId(@Param("unitId") Long unitId);

    KuaiShouGroupTarget getTargetOneByUnitId(Long unitId);

    List<String> getAllAccountId();

    List<String> getAccountIdByMedia(@Param("mediaId") String mediaId);
}
