package cn.com.ctop.job.kuaishou.mapper;

import cn.com.ctop.job.kuaishou.entity.EtlKuaiShouNewly;
import cn.com.ctop.job.kuaishou.entity.EtlKuaishouReportAccountHourly;
import cn.com.ctop.job.kuaishou.entity.JyClipCooperation;
import cn.com.ctop.job.kuaishou.entity.JyClipTopList;
import cn.com.ctop.job.kuaishou.entity.JyOrderList;
import cn.com.ctop.job.kuaishou.entity.KuaiShouCampaign;
import cn.com.ctop.job.kuaishou.entity.KuaiShouDailyFlows;
import cn.com.ctop.job.kuaishou.entity.KuaishouAccountBalanceBudget;
import cn.com.ctop.job.kuaishou.entity.KuaishouPlanCreate;
import cn.com.ctop.job.kuaishou.entity.KuaishouReportDailyAccount;
import cn.com.ctop.job.kuaishou.entity.KuaishouReportDailyCampaign;
import cn.com.ctop.job.kuaishou.entity.RuleDataAccountKuaishou;
import cn.com.ctop.job.kuaishou.entity.RuleDataTargetKuaishou;
import cn.com.ctop.job.kuaishou.entity.RuleDatePlanKuaishou;
import cn.com.ctop.job.kuaishou.entity.RuleDateUnitKuaishou;
import cn.com.ctop.job.kuaishou.entity.TransactionDay;
import cn.com.ctop.job.kuaishou.entity.TransactionDetails;
import cn.com.ctop.job.kuaishou.entity.UserAllocation;
import com.alibaba.fastjson.JSONObject;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

public interface CommonMapper {

    void reloadData();

    String getByAccountId(@Param("accountId") Long accountId);

    List<UserAllocation> listByMediaId(@Param("mediaId") String mediaId, @Param("accountStatus") Integer accountStatus);

    List<Long> getHostingIdList();

    String getCookieById(@Param("id") Long id);

    List<JSONObject> getAccountList();

    void replaceTopItem(@Param("adds") List<JyClipTopList> adds);

    List<JSONObject> getCookie();

    void replaceClipCooperation(@Param("adds") List<JyClipCooperation> adds);

    void replace(@Param("adds") List<JyOrderList> adds);

    void updateAllIsInvalidState();

    void replaceBudget(KuaishouAccountBalanceBudget budget);

    void replaceBatchCampaigns(@Param(value = "campaigns") List<KuaiShouCampaign> campaigns);

    void deleteByAccountId(@Param("accountId") Long accountId, @Param("statDate") String statDate);

    String getCompanyId(@Param("userId") String userId);

    String getLeaderNameByUserId(@Param("userId") String userId);

    Integer getNewPlan(@Param("accountId") Long accountId, @Param("startDate") Date startDate, @Param("endDate") Date endDate);

    Integer getNewUnit(@Param("accountId") Long accountId, @Param("startDate") Date startDate, @Param("endDate") Date endDate);

    Integer getAutoUnit(@Param("accountId") Long accountId, @Param("startDate") Date startDate, @Param("endDate") Date endDate);

    Integer getHostPlan(@Param("accountId") Long accountId, @Param("startDate") Date startDate, @Param("endDate") Date endDate);

    Integer getBatchUnit(@Param("accountId") Long accountId, @Param("startDate") Date startDate, @Param("endDate") Date endDate);

    Integer getMediaCount(@Param("accountId") Long accountId, @Param("startDate") Date startDate, @Param("endDate") Date endDate);

    Integer getEffectiveUnit(@Param("accountId") Long accountId, @Param("startDate") Date startDate, @Param("endDate") Date endDate);

    int insertKuaishouPlanCreate(KuaishouPlanCreate create);

    List<EtlKuaishouReportAccountHourly> queryEveryDayDataForAccount();

    void replaceBatchEveryDayDataForAccount(@Param("list") List<EtlKuaishouReportAccountHourly> list);

    List<EtlKuaishouReportAccountHourly> selectEtlKuaishouReportAccountHourlyList(@Param("startDate") String startDate, @Param("endDate") String endDate);

    void replaceBatchEtlKuaishouReportAccountHourl(@Param("list") List<EtlKuaishouReportAccountHourly> list);

    void etlKuaishouAccountMaterialReportDailyData(@Param(value = "date") String date);

    void replaceBatchKuaishouReportDailyAccount(@Param("addList") List<KuaishouReportDailyAccount> addList);

    void replaceBatchAdSceneKuaishouReportDailyAccount(@Param("addList") List<KuaishouReportDailyAccount> addList);

    void replaceBatchKuaishouReportDailyCampaign(@Param(value = "records") List<KuaishouReportDailyCampaign> campaigns);

    void deleteKuaiShouDailyFlows(@Param("date") String date, @Param("accountId") Long accountId);

    void saveKuaiShouDailyFlows(KuaiShouDailyFlows dailyFlows);

    Integer getCampaignNewDataByAccountIdAndDate(@Param("accountId") Long accountId, @Param("statDate") String statDate);

    Integer getGroupNewDataByAccountIdAndDate(@Param("accountId") Long accountId, @Param("statDate") String statDate);

    Integer getCreativeNewDataByAccountIdAndDate(@Param("accountId") Long accountId, @Param("statDate") String statDate);

    void replaceBatchEtlKuaiShouNewly(@Param("addList") List<EtlKuaiShouNewly> addList);

    void deleteRuleAccountId(@Param("accountId") Long accountId);

    void replaceRuleDataAccount(RuleDataAccountKuaishou ruleDataAccount);

    void deleteRulePlan(@Param("accountId") Long accountId);

    void replaceRuleDataPlan(@Param("batch") List<RuleDatePlanKuaishou> batch);

    void deleteRuleTarge(@Param("accountId") Long accountId);

    void replaceRuleDataTarget(@Param("add") List<RuleDataTargetKuaishou> batch);

    void deleteRuleUnit(@Param("accountId") Long accountId);

    void replaceBatchRuleDateUnitKuaishou(@Param("add") List<RuleDateUnitKuaishou> batch);

    void updateAgentAccountState(List<String> removeList, int i);

    void insertAccountData(@Param("list") List<String> list, @Param("agent_id") String agent_id, @Param("create_time") String create_time);

    List<String> getAccountTransactionDayIdByDate(@Param("date") String date, @Param("advertiserId") String advertiserId);

    void deleteAccountTransactionById( @Param("id") String id);

    void saveAccountTransactionDay(@Param("list") List<TransactionDay> list, @Param("date") String date);

    List<String> getTransactionSeq(@Param("date") String date);

    void saveAccountTransactionDetails(@Param("list") List<TransactionDetails> list, @Param("date") String date);

    void replaceAccountTransactionDay(@Param("list") List<TransactionDay> list);

    List<String> getMd5List();

    void updateBySignature(@Param("signature") String signature);

    List<String> getMaterialInfoCodeList(@Param("date") String date);

    Integer getMaterialInfoCountByCode(@Param("code") String code);

    void updateMaterialInfoByCode(@Param("signature") String signature);

    List<String> getBytedanceCodeList(@Param("date") String date);

    Integer getBytedanceCountByCode(@Param("code") String code);

    void updateByteDanceByCode(@Param("code") String code);

    List<Long> getAccountIds();
}
