package cn.com.ctop.job.kuaishou.service;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.entity.KuaishouAccountBalanceBudget;
import cn.com.ctop.job.kuaishou.entity.UserAllocation;
import com.alibaba.fastjson.JSONObject;

import java.util.Date;
import java.util.List;
import java.util.Map;

public interface CommonService {

    void reloadData();

    String getByAccountId(Long accountId);

    List<UserAllocation> listByMediaId(String type, int i);

    List<Long> getHostingIdList();

    String getCookieById(Long id);

    List<JSONObject> getAccountList();

    void getItemTop(String cookie, Long statDate, Long id, String name, Integer offset);

    List<JSONObject> getCookie();

    void getClipCooperation(String cookie, Integer offset, Long statDate, Integer status) throws Exception;

    void getClipCooperationV2(String cookie, int i, Long statDate, Integer status) throws Exception;

    void getOrderList(String cookie, Integer offset, Long orderCreateTimeStart, Long orderCreateTimeEnd) throws Exception;

    void updateAllIsInvalidState();

    JSONObject fundGet(CtopOauthToken token);

    JSONObject getAccountBudget(CtopOauthToken token);

    void replaceBudget(KuaishouAccountBalanceBudget budget);

    void getCampaignList(CtopOauthToken token, Date startDate, Date endDate);

    void cleanCreateDetail(Long projectId, String userId, String userName, Long accountId, String statDate, Date startDate, Date endDate);

    void queryEveryDayDataForAccount();

    void etlKuaishouAccountMaterialReportDailyData(String formatDate);

    void getAdvertiserReportDaily(CtopOauthToken token, Date startDate, Date endDate, String reportDims);

    void getAdvertiserCampaignReportDaily(CtopOauthToken token, Date getDate, Date endDate);

    void getDailyFlows(CtopOauthToken token);

    void cleanNewlyData(String statDate);

    void deleteRuleAccountId(Long accountId);

    void cleanRuleDataAccount(Long accountId);

    void deleteRulePlan(Long accountId);

    void cleanRuleDataPlan(Long accountId, int i);

    void deleteRuleTarge(Long accountId);

    void cleanRuleDataTarget(Long accountId, String accessToken, int i);

    void deleteRuleUnit(Long accountId);

    void cleanRuleDataUnit(Long accountId, String accessToken, String date2Str, String date2Str1, int i);

    void synchronousAccount();

    void synchronousAccountTransactionDay(String startDate, String endDate);

    void synchronousAccountTransactionDetails(String startDate, String endDate);

    void insertAccountTransactionDay(String startDate, String endDate);

    List<String> getMd5List();

    void updateBySignature(String signature);

    List<String> getMaterialInfoCodeList(String anotherDay);

    Integer getMaterialInfoCountByCode(String code);

    void updateMaterialInfoByCode(String code);

    List<String> getBytedanceCodeList(String anotherDay);

    Integer getBytedanceCountByCode(String code);

    void updateByteDanceByCode(String code);

    List<Long> getAccountIds();
}
