package cn.com.ctop.job.kuaishou.service.impl;

import cn.com.ctop.job.kuaishou.entity.CtopOauthToken;
import cn.com.ctop.job.kuaishou.entity.EtlKuaiShouNewly;
import cn.com.ctop.job.kuaishou.entity.EtlKuaishouReportAccountHourly;
import cn.com.ctop.job.kuaishou.entity.JyClipCooperation;
import cn.com.ctop.job.kuaishou.entity.JyClipTopList;
import cn.com.ctop.job.kuaishou.entity.JyOrderList;
import cn.com.ctop.job.kuaishou.entity.KuaiShouCampaign;
import cn.com.ctop.job.kuaishou.entity.KuaiShouDailyFlows;
import cn.com.ctop.job.kuaishou.entity.KuaiShouGroup;
import cn.com.ctop.job.kuaishou.entity.KuaiShouGroupTarget;
import cn.com.ctop.job.kuaishou.entity.KuaishouAccountBalanceBudget;
import cn.com.ctop.job.kuaishou.entity.KuaishouPlanCreate;
import cn.com.ctop.job.kuaishou.entity.KuaishouReportDailyAccount;
import cn.com.ctop.job.kuaishou.entity.KuaishouReportDailyCampaign;
import cn.com.ctop.job.kuaishou.entity.RuleDataAccountKuaishou;
import cn.com.ctop.job.kuaishou.entity.RuleDataTargetKuaishou;
import cn.com.ctop.job.kuaishou.entity.RuleDatePlanKuaishou;
import cn.com.ctop.job.kuaishou.entity.RuleDateUnitKuaishou;
import cn.com.ctop.job.kuaishou.entity.TransactionDay;
import cn.com.ctop.job.kuaishou.entity.TransactionDetails;
import cn.com.ctop.job.kuaishou.entity.UserAllocation;
import cn.com.ctop.job.kuaishou.mapper.CommonMapper;
import cn.com.ctop.job.kuaishou.service.AccountInfoService;
import cn.com.ctop.job.kuaishou.service.CommonService;
import cn.com.ctop.job.kuaishou.service.ISendMessageService;
import cn.com.ctop.job.kuaishou.service.TokenService;
import cn.com.ctop.job.kuaishou.service.UserService;
import cn.com.ctop.job.kuaishou.utils.Check;
import cn.com.ctop.job.kuaishou.utils.DateUtils;
import cn.com.ctop.job.kuaishou.utils.HttpUtils;
import cn.com.ctop.job.kuaishou.utils.LoadFileUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.xxl.job.core.context.XxlJobHelper;
import lombok.extern.slf4j.Slf4j;
import lombok.var;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpEntityEnclosingRequestBase;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.net.URI;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import static java.util.stream.Collectors.toList;

@Slf4j
@Service
public class CommonServiceImpl implements CommonService {
    @Autowired
    private CommonMapper commonMapper;

    @Autowired
    private ISendMessageService sendMessageService;

    @Autowired
    private UserService userService;

    @Autowired
    private AccountInfoService accountInfoService;

    @Autowired
    private TokenService tokenService;

    @Override
    public void reloadData() {
        commonMapper.reloadData();
    }

    @Override
    public String getByAccountId(Long accountId) {
        return commonMapper.getByAccountId(accountId);
    }

    @Override
    public List<UserAllocation> listByMediaId(String mediaId, int accountStatus) {
        return commonMapper.listByMediaId(mediaId, accountStatus);
    }

    @Override
    public List<Long> getHostingIdList() {
        return commonMapper.getHostingIdList();
    }

    @Override
    public String getCookieById(Long id) {
        return commonMapper.getCookieById(id);
    }

    @Override
    public List<JSONObject> getAccountList() {
        return commonMapper.getAccountList();
    }

    @Override
    public void getItemTop(String cookie, Long statDate, Long id, String name, Integer offset) {
        JSONObject returnJson = new JSONObject();
        Map<String, Object> params = new HashMap<>();
        params.put("activityUserId", id);
        params.put("bizCode", 2);
        params.put("limit", 10);
        params.put("offset", offset);
        Map<String, String> headers = new HashMap<>();
        headers.put("Cookie", cookie);
        String postUrl = "https://cps.kwaixiaodian.com/gateway/distribute/platform/seller/activity/topItem/list";
        String resultStr = null;
        try {
            resultStr = HttpUtils.KuaiShouttpGetRequest(postUrl, params, headers);
        } catch (Exception e) {
            e.printStackTrace();
        }
        JSONObject result = JSONObject.parseObject(resultStr);
        Integer code = result.getInteger("result");
        JSONArray topActivityItemInfo = new JSONArray();
        if (code == 1) {
            JSONObject data = result.getJSONObject("data");
            if (!Check.isNull(data)) {
                topActivityItemInfo = data.getJSONArray("topActivityItemInfo");
                for (int i = 0; i < topActivityItemInfo.size(); i++) {
                    JSONObject jsonObject = topActivityItemInfo.getJSONObject(i);
                    jsonObject.put("statDate", statDate);
                    jsonObject.put("clipId", id);
                    jsonObject.put("clipName", name);
                }

                List<JyClipTopList> adds = topActivityItemInfo.toJavaList(JyClipTopList.class);
                if (!Check.isNull(adds)) {
                    commonMapper.replaceTopItem(adds);
                }
            }
        }

        if (topActivityItemInfo.size() > 0) {
            getItemTop(cookie, statDate, id, name, offset + 10);
        }

    }


    @Override
    public List<JSONObject> getCookie() {
        return commonMapper.getCookie();
    }


    @Override
    public void getClipCooperation(String cookie, Integer offset, Long statDate, Integer status) throws Exception {
        Thread.sleep(2000L);
        Map<String, Object> params = new HashMap<>();
        params.put("status", status);
        params.put("limit", 10);
        params.put("offset", offset);
        Map<String, String> headers = new HashMap<>();
        headers.put("Cookie", cookie);
        String postUrl = "https://cps.kwaixiaodian.com/gateway/distribute/platform/recreate/leader/clip/cooperation/list";
        String resultStr = HttpUtils.httpPostRequest(postUrl, params, headers);
        JSONObject result = JSONObject.parseObject(resultStr);
        if (Check.isNull(result)) {
            log.error("骄阳分销数据返回为空");
            return;
        }
        Integer code = result.getInteger("result");
        if (code != 1) {
            log.info("骄阳分销尔创列表数据返回异常：", resultStr);
            sendMessageService.sendMessage("113dee46c7df464da78c07a985e92cd1", "骄阳分销cookie失效，请及时更新。媒体返回信息：" + resultStr);
            return;
        }
        JSONObject dataJson = result.getJSONObject("data");
        if (Check.isNull(dataJson)) {
            log.error("骄阳分销数据返回为data数据为空");
            return;
        }
        JSONArray list = dataJson.getJSONArray("leaderCoopClip");
        if (Check.isNull(list)) {
            log.error("骄阳分销数据返回为list数据为空");
            return;
        }
        log.info("骄阳分销当前数据条数:{}", list.size());
        List<JyClipCooperation> adds = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            JSONObject jsonObject = list.getJSONObject(i);
            JyClipCooperation clipCooperation = new JyClipCooperation();
            clipCooperation.setClipId(jsonObject.getLong("clipId"));
            clipCooperation.setClipName(jsonObject.getString("clipName"));
            clipCooperation.setHeadImg(jsonObject.getString("headImg"));
            clipCooperation.setCommissionRate(jsonObject.getLong("commissionRate"));
            clipCooperation.setFansNum(jsonObject.getString("fansNum"));
            clipCooperation.setGmv30d(jsonObject.getString("gmv30d"));
            clipCooperation.setStartTime(jsonObject.getString("startTime"));
            clipCooperation.setEndTime(jsonObject.getString("endTime"));
            clipCooperation.setStatus(jsonObject.getInteger("status"));
            clipCooperation.setTerminationReason(jsonObject.getString("terminationReason"));
            clipCooperation.setCommissionRateView(jsonObject.getString("commissionRateView"));
            clipCooperation.setShopScore(jsonObject.getString("shopScore"));
            clipCooperation.setClipGmv30d(jsonObject.getString("clipGmv30d"));
            clipCooperation.setAuthItemGmv30d(jsonObject.getString("authItemGmv30d"));
            clipCooperation.setStatDate(statDate);
           /*  JSONObject getData = this.getClipData(jsonObject.getLong("clipId"), cookie);
           if (!Check.isNull(getData)) {
                clipCooperation.setVideoCount(getData.getString("videoCount"));
                clipCooperation.setVideoShow(getData.getString("videoShow"));
                Thread.sleep(60 * 1000);
            }*/
            adds.add(clipCooperation);


        }
        commonMapper.replaceClipCooperation(adds);
        if (list.size() >= 10) {
            getClipCooperation(cookie, offset + 10, statDate, status);
        }
    }


    @Override
    public void getClipCooperationV2(String cookie, int offset, Long statDate, Integer status) throws Exception {
        Map<String, Object> params = new HashMap<>();
        params.put("status", status);
        params.put("limit", 10);
        params.put("offset", offset);
        Map<String, String> headers = new HashMap<>();
        headers.put("Cookie", cookie);
        String postUrl = "https://cps.kwaixiaodian.com/gateway/distribute/platform/recreate/leader/clip/cooperation/list";
        String resultStr = HttpUtils.httpPostRequest(postUrl, params, headers);
        JSONObject result = JSONObject.parseObject(resultStr);
        if (Check.isNull(result)) {
            log.error("骄阳分销数据返回为空");
            return;
        }
        Integer code = result.getInteger("result");
        if (code != 1) {
            log.info("骄阳分销尔创列表数据返回异常：", resultStr);
            sendMessageService.sendMessage("113dee46c7df464da78c07a985e92cd1", "骄阳分销cookie失效，请及时更新。媒体返回信息：" + resultStr);
            return;
        }
        JSONObject dataJson = result.getJSONObject("data");
        if (Check.isNull(dataJson)) {
            log.error("骄阳分销数据返回为data数据为空");
            return;
        }
        JSONArray list = dataJson.getJSONArray("leaderCoopClip");
        if (Check.isNull(list)) {
            log.error("骄阳分销数据返回为list数据为空");
            return;
        }
        log.info("骄阳分销当前数据条数:{}", list.size());
        List<JyClipCooperation> adds = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            JSONObject jsonObject = list.getJSONObject(i);
            JyClipCooperation clipCooperation = new JyClipCooperation();
            clipCooperation.setClipId(jsonObject.getLong("clipId"));
            clipCooperation.setClipName(jsonObject.getString("clipName"));
            clipCooperation.setHeadImg(jsonObject.getString("headImg"));
            clipCooperation.setCommissionRate(jsonObject.getLong("commissionRate"));
            clipCooperation.setFansNum(jsonObject.getString("fansNum"));
            clipCooperation.setGmv30d(jsonObject.getString("gmv30d"));
            clipCooperation.setStartTime(jsonObject.getString("startTime"));
            clipCooperation.setEndTime(jsonObject.getString("endTime"));
            clipCooperation.setStatus(jsonObject.getInteger("status"));
            clipCooperation.setTerminationReason(jsonObject.getString("terminationReason"));
            clipCooperation.setCommissionRateView(jsonObject.getString("commissionRateView"));
            clipCooperation.setShopScore(jsonObject.getString("shopScore"));
            clipCooperation.setClipGmv30d(jsonObject.getString("clipGmv30d"));
            clipCooperation.setAuthItemGmv30d(jsonObject.getString("authItemGmv30d"));
            clipCooperation.setStatDate(statDate);
            JSONObject getData = this.getClipData(jsonObject.getLong("clipId"), cookie);
            if (!Check.isNull(getData)) {
                clipCooperation.setVideoCount(getData.getString("videoCount"));
                clipCooperation.setVideoShow(getData.getString("videoShow"));
                Thread.sleep(60 * 1000);
            }
            adds.add(clipCooperation);


        }
        commonMapper.replaceClipCooperation(adds);
        if (list.size() >= 10) {
            getClipCooperation(cookie, offset + 10, statDate, status);
        }
    }

    private JSONObject getClipData(Long clipId, String cookie) {
        JSONObject returnJson = new JSONObject();
        Map<String, Object> params = new HashMap<>();
        params.put("clipId", clipId);
        params.put("dimensionType", 1);
        Map<String, String> headers = new HashMap<>();
        headers.put("Cookie", cookie);
        String postUrl = "https://cps.kwaixiaodian.com/gateway/distribute/platform/recreate/leader/clip/cooperation/detail/export";
        String resultStr = HttpUtils.httpPostRequest(postUrl, params, headers);
        JSONObject result = JSONObject.parseObject(resultStr);
        log.info("骄阳获取二创返回结果：{}", result);
        Integer code = result.getInteger("result");
        if (code == 1) {
            JSONObject data = result.getJSONObject("data");
            if (!Check.isNull(data)) {
                String fileUrl = data.getString("fileUrl");
                try {
                    // 创建Workbook对象
                    String localPath = LoadFileUtil.downLoadExcel(fileUrl, "/data/file/jy/", clipId + ".xlsx", cookie);
                    // FileFormat.Ver
                    Workbook workbook = WorkbookFactory.create(new FileInputStream(new File(localPath)));
                    // 获取第一个Sheet对象
                    Sheet sheet = workbook.getSheet("概况");
                    int firstRowNum = sheet.getFirstRowNum();
                    int lastRowNum = sheet.getLastRowNum();
                    for (int rowNum = firstRowNum + 1; rowNum <= lastRowNum; rowNum++) {
                        Row row = sheet.getRow(rowNum);
                        if (row == null) {
                            continue;
                        }
                        int firstCellNum = row.getFirstCellNum();
                        int lastCellNum = row.getLastCellNum();

                        for (int cellNum = firstCellNum; cellNum < lastCellNum; cellNum++) {
                            Cell cell = row.getCell(cellNum);
                            String cellValue = getCellValue(cell);
                            if (cellNum == 4) {
                                returnJson.put("videoCount", cellValue);
                            }
                            if (cellNum == 6) {
                                returnJson.put("videoShow", cellValue);
                            }
                        }
                    }
                    LoadFileUtil.delFile(localPath);
                    // 关闭Workbook对象
                    workbook.close();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        } else {
            log.info("获取文件失败");
        }

        return returnJson;

    }


    public static String getCellValue(Cell cell) {
        String cellValue = "";
        if (cell == null) {
            return cellValue;
        }
        // 把数字当成String来读，避免出现1读成1.0的情况
        if (cell.getCellType() == Cell.CELL_TYPE_NUMERIC) {
            cell.setCellType(Cell.CELL_TYPE_STRING);
        }
        // 判断数据的类型
        switch (cell.getCellType()) {
            case Cell.CELL_TYPE_NUMERIC:
                // 数字
                cellValue = String.valueOf(cell.getNumericCellValue());
                break;
            case Cell.CELL_TYPE_STRING:
                // 字符串
                cellValue = String.valueOf(cell.getStringCellValue());
                break;
            case Cell.CELL_TYPE_BOOLEAN:
                // Boolean
                cellValue = String.valueOf(cell.getBooleanCellValue());
                break;
            case Cell.CELL_TYPE_FORMULA:
                // 公式
                cellValue = String.valueOf(cell.getCellFormula());
                break;
            case Cell.CELL_TYPE_BLANK:
                // 空值
                cellValue = "";
                break;
            case Cell.CELL_TYPE_ERROR:
                // 故障
                cellValue = "非法字符";
                break;
            default:
                cellValue = "未知类型";
                break;
        }

        return cellValue;
    }

    private static String url = "https://cps.kwaixiaodian.com/gateway/distribute/platform/mcn/order/list";

    @Override
    public void getOrderList(String cookie, Integer offset, Long orderCreateTimeStart, Long orderCreateTimeEnd) throws Exception {
        Thread.sleep(3500L);
        log.info("骄阳订单数据入参，开始时间：{},结束时间：{},数据：{}", DateUtils.tempToLongDateStr(orderCreateTimeStart), DateUtils.tempToLongDateStr(orderCreateTimeEnd), offset);
        Map<String, Object> params = new HashMap<>();
        if (!Check.isNull(orderCreateTimeStart)) {
            params.put("orderCreateTimeStart", orderCreateTimeStart);
        }
        if (!Check.isNull(orderCreateTimeEnd)) {
            params.put("orderCreateTimeEnd", orderCreateTimeEnd);
        }
        //  params.put("fundType", 1);
        params.put("limit", 20);
        params.put("offset", offset);
        params.put("timeType", 1);
        Map<String, String> headers = new HashMap<>();
        headers.put("Cookie", cookie);
        headers.put("Accept", "application/json");
        headers.put("Accept-Encoding", "gzip, deflate, br");
        headers.put("Accept-Language", "gzip, deflate, br");
        headers.put("Connection", "keep-alive");
        headers.put("Host", "cps.kwaixiaodian.com");
        headers.put("kpf", "PC_WEB");
        headers.put("Referer", "https://cps.kwaixiaodian.com/pc/leader/base/order-manage");
        headers.put("User-Agent", "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:122.0) Gecko/20100101 Firefox/122.0");
        String resultStr = HttpUtils.KuaiShouttpGetRequest(url, params, headers);
        JSONObject result = JSONObject.parseObject(resultStr);
        if (Check.isNull(result)) {
            log.error("骄阳分销数据返回为空");
            return;
        }
        Integer code = result.getInteger("result");
        if (code != 1) {
            log.info("骄阳分销数据返回异常：", resultStr);
            sendMessageService.sendMessage("113dee46c7df464da78c07a985e92cd1", "骄阳分销cookie失效，请及时更新。媒体返回信息：" + resultStr);
            return;
        }
        JSONObject dataJson = result.getJSONObject("data");
        if (Check.isNull(dataJson)) {
            log.error("骄阳分销数据返回为data数据为空");
            return;
        }
        JSONArray list = dataJson.getJSONArray("list");
        if (Check.isNull(list)) {
            log.error("骄阳分销数据返回为list数据为空");
            return;
        }
        log.info("骄阳分销当前数据条数:{}", list.size());
        List<JyOrderList> orders = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            JSONObject jsonObject = list.getJSONObject(i);
            JyOrderList order = new JyOrderList();
            order.setOid(jsonObject.getLong("oid"));
            JSONObject item = jsonObject.getJSONArray("itemList").getJSONObject(0);
            if (!Check.isNull(item)) {
                order.setItemId(item.getLong("itemId"));
                order.setItemTitle(item.getString("itemTitle"));
                order.setReservePrice(item.getLong("reservePrice"));
                order.setImageUrl(item.getString("imageUrl"));
            }
            order.setOrderStatus(jsonObject.getInteger("orderStatus"));
            order.setOrderCreateTime(jsonObject.getLong("orderCreateTime"));
            order.setSendStatus(jsonObject.getInteger("sendStatus"));
            order.setSettlementBizType(jsonObject.getInteger("settlementBizType"));
            order.setSettlementBizTypeDesc(jsonObject.getString("settlementBizTypeDesc"));
            order.setSendTime(jsonObject.getLong("sendTime"));
            order.setRecvTime(jsonObject.getLong("recvTime"));
            order.setSellerId(jsonObject.getLong("sellerId"));
            order.setPromotionId(jsonObject.getLong("promotionId"));
            order.setPromotionNickName(filterSupplement(jsonObject.getString("promotionNickName")));
            order.setClipUserId(jsonObject.getLong("clipUserId"));
            order.setClipNickName(jsonObject.getString("clipNickName"));
            order.setActivityId(jsonObject.getLong("activityId"));
            order.setOrderAmount(jsonObject.getLong("orderAmount"));
            order.setPayAmount(jsonObject.getLong("payAmount"));
            order.setRegimentalPromotionRate(jsonObject.getLong("regimentalPromotionRate"));
            order.setShareRate(jsonObject.getLong("shareRate"));
            order.setBaseAmount(jsonObject.getLong("baseAmount"));
            order.setCommissionRate(jsonObject.getLong("commissionRate"));
            order.setRegimentalPromotionAmount(jsonObject.getLong("regimentalPromotionAmount"));
            order.setTotalRegimentalSettleAmount(jsonObject.getLong("totalRegimentalSettleAmount"));
            order.setStatDate(DateUtils.tempToLongDate(jsonObject.getLong("orderCreateTime")));
            order.setStatHour(DateUtils.getHour(jsonObject.getLong("orderCreateTime")));
            order.setMcnPromotionAmount(jsonObject.getLong("mcnPromotionAmount"));
            order.setMcnSettlementAmount(jsonObject.getLong("mcnSettlementAmount"));
            orders.add(order);
        }
        commonMapper.replace(orders);
        if (list.size() >= 20) {
            getOrderList(cookie, offset + 20, orderCreateTimeStart, orderCreateTimeEnd);
        }

    }

    public static String filterSupplement(String content) {
        StringBuilder sb = new StringBuilder();
        for (char ch : content.toCharArray()) {
            if (!Character.isHighSurrogate(ch) && !Character.isLowSurrogate(ch)) {
                sb.append(ch);
            }
        }
        return sb.toString();
    }


    @Override
    public void updateAllIsInvalidState() {
        commonMapper.updateAllIsInvalidState();
    }

    /**
     * 获取账户余额
     *
     * @param oauthToken
     * @return
     */
    @Override
    public JSONObject fundGet(CtopOauthToken oauthToken) {
        try {
            //获取账户余额
            String url = "https://ad.e.kuaishou.com/rest/openapi/v1/advertiser/fund/get";
            Map<String, String> headers = new HashMap<>();
            headers.put("Access-Token", oauthToken.getAccessToken());
            headers.put("Content-Type", " application/json");
            JSONObject json = new JSONObject();
            json.put("advertiser_id", oauthToken.getAccountId());
            String result = HttpUtils.kuaiShouhttpPostRequest(url, json.toJSONString(), headers);
            JSONObject resultJson = JSONObject.parseObject(result);
            if (!Check.isNull(resultJson)) {
                Integer code = resultJson.getInteger("code");
                if (code == 0) {
                    JSONObject dataJson = resultJson.getJSONObject("data");
                    if (!Check.isNull(dataJson)) {
                        return dataJson;
                    }
                } else {
                    log.error("获取账户余额失败，" + resultJson.getString("message"));
                }
            } else {
                log.error("获取账户余额返回为空");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public JSONObject getAccountBudget(CtopOauthToken oauthToken) {
        //账户日预算查询
        String url = "https://ad.e.kuaishou.com/rest/openapi/v1/advertiser/budget/get";
        Map<String, String> headers = new HashMap<>();
        headers.put("Access-Token", oauthToken.getAccessToken());
        headers.put("Content-Type", "application/json");
        JSONObject json = new JSONObject();
        json.put("advertiser_id", oauthToken.getAccountId());
        String result = HttpUtils.kuaiShouhttpPostRequest(url, json.toJSONString(), headers);
        try {
            Thread.sleep(500);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        JSONObject resultJson = JSONObject.parseObject(result);
        if (!Check.isNull(resultJson)) {
            Integer code = resultJson.getInteger("code");
            if (code == 0) {
                JSONObject dataJson = resultJson.getJSONObject("data");
                if (!Check.isNull(dataJson)) {
                    return dataJson;
                }
            } else {
                log.error("获取账户日预算失败，返回信息：{}", resultJson);
            }
        }
        return null;
    }

    @Override
    public void replaceBudget(KuaishouAccountBalanceBudget budget) {
        commonMapper.replaceBudget(budget);
    }

    @Override
    public void getCampaignList(CtopOauthToken token, Date startDate, Date endDate) {
        getCampaignListByPage(token.getAccessToken(), token.getAccountId(), startDate, endDate, 1);
    }

    private void getCampaignListByPage(String accessToken, Long accountId, Date startDate, Date endDate, int page) {
        //广告计划信息
        String url = "https://ad.e.kuaishou.com/rest/openapi/v1/campaign/list";
        Map<String, String> headers = new HashMap<>();
        headers.put("Access-Token", accessToken);
        headers.put("Content-Type", " application/json");
        JSONObject param = new JSONObject();
        param.put("advertiser_id", accountId);
        if (startDate != null && endDate != null) {
            param.put("start_date", DateUtils.formatDate(startDate));
            param.put("end_date", DateUtils.formatDate(endDate));
        }
        param.put("page", page);
        param.put("page_size", 500);

        String result = HttpUtils.kuaiShouhttpPostRequest(url, param.toJSONString(), headers);
        JSONObject resultJson = JSONObject.parseObject(result);
        if (Check.isNull(resultJson)) {
            log.error("获取广告计划信息返回结果异常,advertiserId:{}", accountId);
            return;
        }
        Integer code = resultJson.getInteger("code");
        if (null == code || code != 0) {
            log.error("获取广告计划信息返回结果异常,advertiserId:{},异常信息:{}", accountId, resultJson);
            return;
        }
        JSONObject dataJson = resultJson.getJSONObject("data");
        JSONArray details = dataJson.getJSONArray("details");
        if (Check.isNull(details)) {
            return;
        }
        addCampaign(accountId, details);
        getCampaignListByPage(accessToken, accountId, startDate, endDate, page + 1);
    }


    private void addCampaign(Long advertiserId, JSONArray details) {
        List<KuaiShouCampaign> campaigns = new ArrayList<>();
        for (int i = 0; i < details.size(); i++) {
            JSONObject detail = JSONObject.parseObject(details.get(i).toString());
            if (!Check.isNull(detail)) {
                KuaiShouCampaign campaign = new KuaiShouCampaign();
                campaign.setId("" + advertiserId + detail.getLong("campaign_id"));
                campaign.setAccountId(advertiserId);
                campaign.setCampaignId(detail.getLong("campaign_id"));
                campaign.setCampaignName(detail.getString("campaign_name"));
                campaign.setDayBudget(detail.getLong("day_budget"));
                if (!Check.isNull(detail.getJSONArray("day_budget_schedule"))) {
                    campaign.setDayBudgetSchedule(detail.getJSONArray("day_budget_schedule").toJSONString());
                }
                campaign.setStatus(detail.getInteger("status"));
                campaign.setPutStatus(detail.getInteger("put_status"));
                campaign.setCampaignType(detail.getInteger("campaign_type"));
                campaign.setCreateChannel(detail.getInteger("create_channel"));
                campaign.setPutCreateTime(detail.getString("create_time"));
                campaign.setPutUpdateTime(detail.getString("update_time"));

                campaigns.add(campaign);
            }
        }
        commonMapper.replaceBatchCampaigns(campaigns);
    }

    @Override
    public void cleanCreateDetail(Long projectId, String userId, String userName, Long accountId, String statDate, Date startDate, Date endDate) {
        commonMapper.deleteByAccountId(accountId, statDate);
        KuaishouPlanCreate create = new KuaishouPlanCreate();
        create.setAccountId(accountId);
        create.setUserId(userId);
        create.setUserName(userName);
        create.setProjectId(projectId);
        create.setStatDate(statDate);
        String companyId = commonMapper.getCompanyId(userId);
        create.setCompanyId(companyId);
        String leaderName = commonMapper.getLeaderNameByUserId(userId);
        create.setLeaderName(leaderName);
        Integer planCount = commonMapper.getNewPlan(accountId, startDate, endDate);
        Integer newUnitCount = commonMapper.getNewUnit(accountId, startDate, endDate);
        if (planCount == 0 && newUnitCount == 0) {
            return;
        }
        create.setNewPlan(planCount);
        create.setNewUnit(newUnitCount);
        Integer autoUnitCount = commonMapper.getAutoUnit(accountId, startDate, endDate);
        create.setAutoUnit(autoUnitCount);

        // 智能托管新建计划数（助手）
        Integer hostPlan = commonMapper.getHostPlan(accountId, startDate, endDate);
        create.setHostingPlans(hostPlan);

        // 批量工具创建组数量
        Integer batch = commonMapper.getBatchUnit(accountId, startDate, endDate);
        if (batch != 0) {
            Integer batchCount = batch - autoUnitCount;
            if (batchCount >= 0) {
                create.setBatchUnit(batchCount);
            } else {
                create.setBatchUnit(0);
            }
        } else {
            create.setBatchUnit(0);
        }
        // 媒体后台创建组数量 （不包含助手智能托管组）
        Integer mediaCount = commonMapper.getMediaCount(accountId, startDate, endDate);
        create.setMediaUnit(mediaCount);

        Integer effectiveUnitCount = commonMapper.getEffectiveUnit(accountId, startDate, endDate);
        create.setEffectiveUnit(effectiveUnitCount);
        int insert = commonMapper.insertKuaishouPlanCreate(create);
        if (insert > 0) {
            log.info("账户创建汇总清洗完成，accountId：{}，stat_date：{}", accountId, statDate);
        }
    }

    @Override
    public void queryEveryDayDataForAccount() {
        List<EtlKuaishouReportAccountHourly> list = commonMapper.queryEveryDayDataForAccount();
        if (!Check.isNull(list)) {
            commonMapper.replaceBatchEveryDayDataForAccount(list);
        }
        updateYesterdayEtlHourlyData();
    }

    @Override
    public void etlKuaishouAccountMaterialReportDailyData(String formatDate) {
        commonMapper.etlKuaishouAccountMaterialReportDailyData(formatDate);

    }

    public void updateYesterdayEtlHourlyData() {
        //昨天日期
        String lastStartDate = DateUtils.getLastDay(DateUtils.formatDate(new Date()), 1);
        List<EtlKuaishouReportAccountHourly> list = commonMapper.selectEtlKuaishouReportAccountHourlyList(lastStartDate, lastStartDate);
        if (!Check.isNull(list)) {
            for (EtlKuaishouReportAccountHourly accountHourly : list) {
                accountHourly.setStatHour(23l);
            }
            commonMapper.replaceBatchEtlKuaishouReportAccountHourl(list);
        }
    }

    @Override
    public void getAdvertiserReportDaily(CtopOauthToken token, Date startDate, Date endDate, String reportDims) {
        try {
            Thread.sleep(400L);
            getAccountDailyReportByPage(token, startDate, endDate, 1, reportDims);
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    private void getAccountDailyReportByPage(CtopOauthToken token, Date startDate, Date endDate, int page, String reportDims) {
        //广告计划报表数据
        String url = "https://ad.e.kuaishou.com/rest/openapi/v1/report/campaign_report";
        Map<String, String> headers = new HashMap<>();
        headers.put("Content-Type", "application/json");
        headers.put("Access-Token", token.getAccessToken());
        Map<String, Object> param = new HashMap<>();
        if (!Check.isNull(startDate)) {
            param.put("start_date", DateUtils.formatDate(startDate));
        }

        if (!Check.isNull(endDate)) {
            param.put("end_date", DateUtils.formatDate(endDate));
        }
        if (!Check.isNull(reportDims)) {
            JSONArray array = new JSONArray();
            array.add(reportDims);
            param.put("report_dims", array);
        }

        param.put("advertiser_id", token.getAccountId());
        param.put("temporal_granularity", "DAILY");
        param.put("page_size", 2000);
        param.put("page", page);
        String result = HttpUtils.httpPostRequest(url, param, headers);
        try {
            Thread.sleep(500);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        JSONObject resultJson = JSONObject.parseObject(result);
        Integer code = resultJson.getInteger("code");
        String message = resultJson.getString("message");
        if (null == code || code != 0) {
            log.error("获取快手广告主报表异常:{},accountId:{}", message, token.getAccountId());
            return;
        }
        JSONArray details = resultJson.getJSONObject("data").getJSONArray("details");
        if (null == details || details.size() <= 0) {
            log.info("快手广告主报表信息为空=》accountId:{}", token.getAccountId());
            return;
        }
        List<KuaishouReportDailyAccount> addList = new ArrayList<>();
        for (int i = 0; i < details.size(); i++) {
            JSONObject detailJson = details.getJSONObject(i);
            if (!Check.isNull(detailJson)) {
                detailJson.put("photo_share", detailJson.getString("share"));
                detailJson.put("photo_comment", detailJson.getString("comment"));
                detailJson.put("photo_like", detailJson.getString("like"));
                detailJson.put("photo_show", detailJson.getString("show"));
                KuaishouReportDailyAccount KuaishouReportDailyAccount = JSONObject.toJavaObject(detailJson, KuaishouReportDailyAccount.class);
                KuaishouReportDailyAccount.setAccountId(token.getAccountId());
                addList.add(KuaishouReportDailyAccount);
            }
        }
        if (Check.isNull(reportDims)) {
            commonMapper.replaceBatchKuaishouReportDailyAccount(addList);
        } else {
            commonMapper.replaceBatchAdSceneKuaishouReportDailyAccount(addList);
        }
        getAccountDailyReportByPage(token, startDate, endDate, page + 1, reportDims);
    }

    @Override
    public void getAdvertiserCampaignReportDaily(CtopOauthToken token, Date startDate, Date endDate) {
        getCampaignDailyReportByPage(token, startDate, endDate, 1);
    }

    private void getCampaignDailyReportByPage(CtopOauthToken token, Date startDate, Date endDate, int page) {
        //广告计划报表数据
        String url = "https://ad.e.kuaishou.com/rest/openapi/v1/report/campaign_report";
        Map<String, String> headers = new HashMap<>();
        headers.put("Content-Type", "application/json");
        headers.put("Access-Token", token.getAccessToken());
        Map<String, Object> param = new HashMap<>();

        if (!Check.isNull(startDate)) {
            param.put("start_date", DateUtils.formatDate(startDate));
        }
        if (!Check.isNull(endDate)) {
            param.put("end_date", DateUtils.formatDate(endDate));
        }
        param.put("advertiser_id", token.getAccountId());
        param.put("temporal_granularity", "DAILY");
        param.put("page_size", 500);
        param.put("page", page);

        String result = HttpUtils.httpPostRequest(url, param, headers);
        try {
            Thread.sleep(500);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        JSONObject resultJson = JSONObject.parseObject(result);
        Integer code = resultJson.getInteger("code");
        String message = resultJson.getString("message");
        if (null == code || code != 0) {
            log.error("获取快手广告计划报表异常:{},accountId:{}", message, token.getAccountId());
            return;
        }
        JSONArray details = resultJson.getJSONObject("data").getJSONArray("details");
        if (null == details || details.size() <= 0) {
            log.info("快手广告计划报表信息为空=》accountId:{}", token.getAccountId());
            return;
        }

        List<KuaishouReportDailyCampaign> campaigns = new ArrayList<>();
        for (int i = 0; i < details.size(); i++) {
            var detailJson = details.getJSONObject(i);
            var show = detailJson.getLong("show");
            detailJson.put("photo_show", show);
            var like = detailJson.getLong("like");
            detailJson.put("photo_like", like);
            var campaign = JSONObject.toJavaObject(detailJson, KuaishouReportDailyCampaign.class);
            campaign.setAccountId(token.getAccountId());
            campaigns.add(campaign);
        }
        if (!campaigns.isEmpty()) {
            commonMapper.replaceBatchKuaishouReportDailyCampaign(campaigns);
        }
        getCampaignDailyReportByPage(token, startDate, endDate, page + 1);
    }


    @Override
    public void getDailyFlows(CtopOauthToken token) {
        try {
            //获取账户流水数据
            String url = "https://ad.e.kuaishou.com/rest/openapi/v1/advertiser/fund/daily_flows";
            Map<String, String> headers = new HashMap<>();
            headers.put("Access-Token", token.getAccessToken());
            headers.put("Content-Type", " application/json");
            JSONObject json = new JSONObject();
            json.put("advertiser_id", token.getAccountId());
            String endDate = DateUtils.getNowDate("yyyy-MM-dd");
            String startDate = DateUtils.getAnotherDay("yyyy-MM-dd", endDate, -2);
            json.put("start_date", startDate);
            json.put("end_date", endDate);
            String result = HttpUtils.kuaiShouhttpPostRequest(url, json.toJSONString(), headers);
            JSONObject resultJson = JSONObject.parseObject(result);
            if (!Check.isNull(resultJson)) {
                Integer code = resultJson.getInteger("code");
                if (code == 0) {
                    JSONObject dataJson = resultJson.getJSONObject("data");
                    if (!Check.isNull(dataJson)) {
                        JSONArray details = dataJson.getJSONArray("details");
                        if (!Check.isNull(details)) {
                            for (int i = 0; i < details.size(); i++) {
                                JSONObject detailJson = details.getJSONObject(i);
                                if (!Check.isNull(detailJson)) {
                                    String date = detailJson.getString("date");
                                    Map<String, Object> deleteMap = new HashMap<>();
                                    deleteMap.put("date", date);
                                    deleteMap.put("account_id", token.getAccountId());
                                    commonMapper.deleteKuaiShouDailyFlows(date, token.getAccountId());
                                    KuaiShouDailyFlows dailyFlows = new KuaiShouDailyFlows();
                                    dailyFlows.setAccountId(token.getAccountId());
                                    dailyFlows.setDate(date);
                                    dailyFlows.setBalance(detailJson.getBigDecimal("balance"));
                                    dailyFlows.setDailyCharge(detailJson.getBigDecimal("daily_charge"));
                                    dailyFlows.setRealCharged(detailJson.getBigDecimal("real_charged"));
                                    dailyFlows.setContractRebateRealCharged(detailJson.getBigDecimal("contract_rebate_real_charged"));
                                    dailyFlows.setDirectRebateRealCharged(detailJson.getBigDecimal("direct_rebate_real_charged"));
                                    dailyFlows.setDailyTransferIn(detailJson.getBigDecimal("daily_transfer_in"));
                                    dailyFlows.setContractRebateRealRecharged(detailJson.getBigDecimal("contract_rebate_real_recharged"));
                                    dailyFlows.setDirectRebateRealRecharged(detailJson.getBigDecimal("direct_rebate_real_recharged"));
                                    dailyFlows.setDailyTransferOut(detailJson.getBigDecimal("daily_transfer_out"));
                                    dailyFlows.setRealRecharged(detailJson.getBigDecimal("real_recharged"));
                                    commonMapper.saveKuaiShouDailyFlows(dailyFlows);
                                }
                            }
                        }
                    }

                } else {
                    log.error("获取账户余额失败");
                }
            } else {
                log.error("获取账户余额返回为空");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    private static List<String> typeList = new ArrayList();

    /**
     * 清洗上新数量
     */
    @Override
    public void cleanNewlyData(String statDate) {
        List<UserAllocation> userAllocations = commonMapper.listByMediaId("2", 0);
        if (Check.isNull(userAllocations)) {
            return;
        }
        Map<Long, Long> projectIdMap = new HashMap<>();
        Map<String, String> userIdMap = new HashMap<>();
        for (UserAllocation allocation : userAllocations) {
            if (!Check.isNull(allocation.getProjectId())) {
                projectIdMap.put(allocation.getProjectId(), allocation.getProjectId());
            }
            if (!Check.isNull(allocation.getUserId())) {
                userIdMap.put(allocation.getUserId(), allocation.getUserId());
            }
        }
        Map<String, String> userMap = userService.getUserMapByMap(userIdMap);

        Map<Long, String> projectMap = userService.getProjectMap(projectIdMap);

        List<EtlKuaiShouNewly> addList = new ArrayList<>();
        if (Check.isNull(typeList)) {
            getTypeList();
        }
        for (int i = 0; i < typeList.size(); i++) {
            String newType = typeList.get(i);
            for (UserAllocation allocation : userAllocations) {
                EtlKuaiShouNewly addNewly = new EtlKuaiShouNewly();
                addNewly.setAccountId(allocation.getAccountId());
                addNewly.setOauthName(allocation.getAuthName());
                addNewly.setProjectId(allocation.getProjectId());
                if (!Check.isNullMap(projectMap)) {
                    addNewly.setProjectName(projectMap.get(allocation.getProjectId()));
                }
                addNewly.setUserId(allocation.getUserId());
                if (!Check.isNullMap(userMap)) {
                    addNewly.setUserName(userMap.get(allocation.getUserId()));
                }
                Integer count = 0;
                if (newType.equals("campaign")) {
                    count = commonMapper.getCampaignNewDataByAccountIdAndDate(allocation.getAccountId(), statDate);
                } else if (newType.equals("unit")) {
                    count = commonMapper.getGroupNewDataByAccountIdAndDate(allocation.getAccountId(), statDate);
                } else if (newType.equals("creative")) {
                    count = commonMapper.getCreativeNewDataByAccountIdAndDate(allocation.getAccountId(), statDate);
                }
                addNewly.setNewCount(count);
                addNewly.setNewType(newType);
                addNewly.setStatDate(statDate);
                addList.add(addNewly);
            }
            if (!Check.isNull(addList)) {
                commonMapper.replaceBatchEtlKuaiShouNewly(addList);
                addList = new ArrayList<>();
            }
        }
    }

    private void getTypeList() {
        typeList.add("campaign");
        typeList.add("unit");
        typeList.add("creative");
    }

    @Override
    public void deleteRuleAccountId(Long accountId) {
        commonMapper.deleteRuleAccountId(accountId);
    }

    @Override
    public void cleanRuleDataAccount(Long accountId) {
        CtopOauthToken oauthToken = tokenService.getTokenByAccountId(accountId);
        //查询账户实时数据
        JSONObject dataAccount = accountInfoService.getAccountReportBy(oauthToken, accountId);
        if (!dataAccount.isEmpty()) {
            JSONObject fundData = accountInfoService.getAccountFundBy(oauthToken, accountId);
            RuleDataAccountKuaishou ruleDataAccount = new RuleDataAccountKuaishou();
            ruleDataAccount.setId(accountId);
            ruleDataAccount.setAccountName(userService.getOneByAccountId(accountId).getAuthName());
            ruleDataAccount.setAccountId(accountId);
            ruleDataAccount.setCost(dataAccount.getBigDecimal("charge"));
            ruleDataAccount.setValidBalance(fundData.getBigDecimal("balance"));
            commonMapper.replaceRuleDataAccount(ruleDataAccount);
        }
    }

    @Override
    public void deleteRulePlan(Long accountId) {
        commonMapper.deleteRulePlan(accountId);
    }


    @Override
    public void cleanRuleDataPlan(Long accountId, int page) {
        JSONObject param = new JSONObject();
        param.put("advertiser_id", accountId);
        param.put("page_size", 500);
        param.put("page", page);

        Map<String, String> headers = new HashMap<>();
        headers.put("Access-Token", tokenService.getTokenByAccountId(accountId).getAccessToken());
        headers.put("Content-Type", "application/json");

        String result = HttpUtils.kuaiShouhttpPostRequest("https://ad.e.kuaishou.com/rest/openapi/v1/campaign/list", param.toJSONString(), headers);
        JSONObject resultJson = JSONObject.parseObject(result);
        if (Check.isNull(resultJson)) {
            XxlJobHelper.log("获取广告计划接口异常,advertiserId:{}", accountId);
            return;
        }
        Integer code = resultJson.getInteger("code");
        if (null == code || code != 0) {
            XxlJobHelper.log("获取广告计划返回结果异常,advertiserId:{},异常信息:{}", accountId, resultJson);
            return;
        }
        JSONArray details = resultJson.getJSONObject("data").getJSONArray("details");
        if (Check.isNull(details)) {
            return;
        }
        this.insertPlan(accountId, details);
        cleanRuleDataPlan(accountId, page + 1);
    }

    private void insertPlan(Long accountId, JSONArray details) {
        List<RuleDatePlanKuaishou> batch = new ArrayList<>();
        details.forEach(detail -> {
            JSONObject planDetail = (JSONObject) detail;
            RuleDatePlanKuaishou plan = new RuleDatePlanKuaishou();
            if (planDetail.getInteger("status") == 4 && planDetail.getInteger("put_status") == 1) {
                plan.setId(planDetail.getLong("campaign_id"));
                plan.setAccountId(accountId);
                plan.setPlanId(planDetail.getLong("campaign_id"));
                plan.setPlanName(planDetail.getString("campaign_name"));
                batch.add(plan);
            }
        });
        if (!batch.isEmpty()) {
            commonMapper.replaceRuleDataPlan(batch);
        }
    }

    @Override
    public void deleteRuleTarge(Long accountId) {
        commonMapper.deleteRuleTarge(accountId);
    }

    @Override
    public void cleanRuleDataTarget(Long accountId, String accessToken, int page) {
        JSONObject param = new JSONObject();
        param.put("advertiser_id", accountId);
        param.put("page_size", 500);
        param.put("page", page);
        String nowDate = DateUtils.getNowDate("yyyy-MM-dd");
        param.put("start_date", nowDate);
        param.put("end_date", nowDate);

        Map<String, String> headers = new HashMap<>();
        headers.put("Access-Token", accessToken);
        headers.put("Content-Type", "application/json");

        String result = HttpUtils.kuaiShouhttpPostRequest("https://ad.e.kuaishou.com/rest/openapi/v1/ad_unit/list", param.toJSONString(), headers);
        JSONObject resultJson = JSONObject.parseObject(result);
        if (Check.isNull(resultJson)) {
            XxlJobHelper.log("获取定向信息接口异常,advertiserId:{}", accountId);
            return;
        }
        Integer code = resultJson.getInteger("code");
        if (null == code || code != 0) {
            XxlJobHelper.log("获取定向信息返回结果异常,advertiserId:{},异常信息:{}", accountId, resultJson);
            return;
        }
        JSONArray details = resultJson.getJSONObject("data").getJSONArray("details");
        if (Check.isNull(details)) {
            return;
        }

        this.insertTarget(accountId, details);
        cleanRuleDataTarget(accountId, accessToken, page + 1);
    }

    private void insertTarget(Long accountId, JSONArray details) {
        List<RuleDataTargetKuaishou> batch = new ArrayList<>();
        details.forEach(detail -> {
            JSONObject unitDetail = (JSONObject) detail;
            RuleDataTargetKuaishou target = new RuleDataTargetKuaishou();
            Integer status = unitDetail.getInteger("status");
            Integer putStatus = unitDetail.getInteger("put_status");
            if ((status == 20 || status == 19) && putStatus == 1) {
                target.setId(unitDetail.getLong("unit_id"));
                target.setAccountId(accountId);
                target.setPlanId(unitDetail.getLong("campaign_id"));
                target.setUnitId(unitDetail.getLong("unit_id"));
                target.setSceneId(unitDetail.getJSONArray("scene_id") == null ? "" : unitDetail.getJSONArray("scene_id").toString());
                //获取组定向信息
                JSONObject unitTarget = unitDetail.getJSONObject("target");
                //地域
                JSONArray region = unitTarget.getJSONArray("region");
                target.setRegion(region == null ? "" : region.toJSONString());
                //性别
                Integer gender = unitDetail.getJSONObject("target").getInteger("gender");
                target.setGender(gender == null ? 0 : gender);
                //年龄
                JSONArray agesRange = unitTarget.getJSONArray("ages_range");
                target.setAgesRange(agesRange == null ? "" : agesRange.toJSONString());
                //操作系统
                Integer platformOs = unitTarget.getInteger("platform_os");
                target.setPlatformOs(platformOs == null ? 0 : platformOs);
                //设类类型
                JSONArray deviceBrand = unitTarget.getJSONArray("device_brand");
                target.setDeviceBrand(deviceBrand == null ? "" : deviceBrand.toJSONString());
                //设备价格
                JSONArray devicePrice = unitTarget.getJSONArray("device_price");
                target.setDevicePrice(devicePrice == null ? "" : devicePrice.toJSONString());
                //过滤已转化人群
                Integer filterConvertedLevel = unitTarget.getInteger("filter_converted_level");
                target.setFilterConvertedLevel(filterConvertedLevel);
                //人群包定向
                JSONArray population = unitTarget.getJSONArray("population");
                target.setPopulation(population == null ? "" : population.toJSONString());
                //人群包排除
                JSONArray excludePopulation = unitTarget.getJSONArray("exclude_population");
                target.setExcludePopulation(excludePopulation == null ? "" : excludePopulation.toJSONString());
                //应用商店
                JSONArray appStore = unitDetail.getJSONArray("app_store");
                target.setAppStore(appStore == null ? "" : appStore.toJSONString());
                //商业兴趣
                JSONArray businessInterest = unitTarget.getJSONArray("business_interest");
                target.setBusinessInterest(businessInterest == null ? "" : businessInterest.toJSONString());
                //网络环境
                Integer network = unitTarget.getInteger("network");
                target.setNetwork(network == null ? 0 : network);

                JSONObject intelliExtend = unitDetail.getJSONObject("target").getJSONObject("intelli_extend");
                Integer isOpen = 0;
                if (!Check.isNull(intelliExtend)) {
                    isOpen = intelliExtend.getInteger("is_open");
                }

                target.setIsOpen(isOpen);

                target.setDeepConversionBid(new BigDecimal(unitDetail.getLong("deep_conversion_bid")).divide(new BigDecimal("1000")));
                target.setDeepConversionType(unitDetail.getInteger("deep_conversion_type"));
                target.setOcpxActionType(unitDetail.getInteger("ocpx_action_type"));
                target.setCpaBid(new BigDecimal(unitDetail.getLong("cpa_bid")).divide(new BigDecimal("1000"), 2, RoundingMode.HALF_UP));
                target.setScheduleTime(unitDetail.getString("schedule_time") == null ? "" : unitDetail.getString("schedule_time"));
                target.setCreateTime(new Date());
                target.setUpdateTime(new Date());
                target.setStatus(1);
                batch.add(target);
            }
        });
        if (!batch.isEmpty()) {
            commonMapper.replaceRuleDataTarget(batch);
        }
    }

    @Override
    public void deleteRuleUnit(Long accountId) {
        commonMapper.deleteRuleUnit(accountId);
    }

    @Override
    public void cleanRuleDataUnit(Long accountId, String accessToken, String startDate, String endDate, int page) {
        JSONObject param = new JSONObject();
        param.put("advertiser_id", accountId);
        param.put("page_size", 500);
        param.put("page", page);
        param.put("start_date", startDate);
        param.put("end_date", endDate);

        Map<String, String> headers = new HashMap<>();
        headers.put("Access-Token", accessToken);
        headers.put("Content-Type", "application/json");

        String result = HttpUtils.kuaiShouhttpPostRequest("https://ad.e.kuaishou.com/rest/openapi/v1/report/unit_report", param.toJSONString(), headers);
        JSONObject resultJson = JSONObject.parseObject(result);
        if (Check.isNull(resultJson)) {
            XxlJobHelper.log("获取广告组报表接口异常,advertiserId:{}", accountId);
            return;
        }
        Integer code = resultJson.getInteger("code");
        if (null == code || code != 0) {
            XxlJobHelper.log("获取广告组报表返回结果异常,advertiserId:{},异常信息:{}", accountId, resultJson);
            return;
        }
        JSONArray details = resultJson.getJSONObject("data").getJSONArray("details");
        if (Check.isNull(details)) {
            return;
        }
        //添加执行刷新 广告组定向信息功能
        CtopOauthToken token = tokenService.getTokenByAccountId(accountId);
        accountInfoService.getGroupListByAccountId(token.getAccessToken(), accountId);
        this.insertUnit(accountId, details);
        cleanRuleDataUnit(accountId, accessToken, startDate, endDate, page + 1);
    }


    private void insertUnit(Long accountId, JSONArray details) {
        List<RuleDateUnitKuaishou> batch = new ArrayList<>();
        details.forEach(detail -> {
            JSONObject unitDetail = (JSONObject) detail;
            RuleDateUnitKuaishou unit = new RuleDateUnitKuaishou();
            KuaiShouGroup group = accountInfoService.getGroupOneByUnitId(unitDetail.getLong("unit_id"));
            if (group != null) {
                Integer status = group.getStatus();
                Integer putStatus = group.getPutStatus();
                if ((status == 20 || status == 19) && putStatus == 1) {
                    KuaiShouGroupTarget groupTarget = accountInfoService.getTargetOneByUnitId(unitDetail.getLong("unit_id"));
                    if (!Check.isNull(groupTarget)) {
                        unit.setAndroidOsv(groupTarget.getAndroidOsv());
                    }
                    unit.setId(unitDetail.getLong("unit_id"));
                    unit.setAccountId(accountId);
                    unit.setPlanId(unitDetail.getLong("campaign_id"));
                    unit.setUnitId(unitDetail.getLong("unit_id"));
                    unit.setUnitName(unitDetail.getString("unit_name"));
                    unit.setCharge(unitDetail.getBigDecimal("charge"));
                    //未知优化目标数据存空
                    if (group.getOcpxActionType() != 0) {
                        unit.setConvertNum(handleConvertNum(group.getOcpxActionType(), unitDetail));
                        if (null != unit.getConvertNum() && unit.getConvertNum() != 0) {
                            unit.setConvertCost(unitDetail.getBigDecimal("charge").divide(BigDecimal.valueOf(unit.getConvertNum()), 2, RoundingMode.HALF_UP));
                        }
                    }
                    unit.setCreateTime(new Date());
                    unit.setStatus(1);
                    batch.add(unit);
                }
            }

        });
        if (!batch.isEmpty()) {
            commonMapper.replaceBatchRuleDateUnitKuaishou(batch);
        }
    }

    /**
     * 53：提交线索，form_count
     * 180：激活，activation
     * 190: 付费，event_pay
     * 191：首日ROI，event_pay_roi
     * 348：有效线索，event_valid_clues
     * 383: 授信，event_credit_grant_app
     * 384: 完件 event_jin_jian_app
     * 715：微信复制 event_add_wechat
     *
     * @param ocpxActionType
     * @param detail
     * @return
     */
    private Long handleConvertNum(int ocpxActionType, JSONObject detail) {
        Long convertNum = null;
        switch (ocpxActionType) {
            case 2:
                convertNum = detail.getLong("bclick");
                break;
            case 10:
                convertNum = detail.getLong("aclick");
                break;
            case 11:
                convertNum = detail.getLong("photo_click");
                break;
            case 31:
                convertNum = detail.getLong("download_completed");
                break;
            case 53:
                convertNum = detail.getLong("form_count");
                break;
            case 180:
                convertNum = detail.getLong("activation");
                break;
            case 190:
                convertNum = detail.getLong("event_pay");
                break;
            case 191:
                convertNum = detail.getDouble("event_pay_first_day_roi").longValue();
                break;
            case 348:
                convertNum = detail.getLong("event_valid_clues");
                break;
            case 383:
                convertNum = detail.getLong("event_credit_grant_app");
                break;
            case 384:
                convertNum = detail.getLong("event_jin_jian_app");
                break;
            case 715:
                convertNum = detail.getLong("event_add_wechat");
                break;
        }
        return convertNum;
    }

    /**
     * 同步代理商下账号 zzy
     */
    @Override
    public void synchronousAccount() {
        String accountList = "1651537304110087;1640370875427848;73970348172";
        log.info("开始同步账号信息");
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");//设置日期格式
        List<String> dataList = new ArrayList();
        try {
            if (accountList != null) {
                String[] split = accountList.split(";");
                for (String account : split) {
                    //分页查询第一页数据
                    JSONObject agentAccountList = selectAgentAdvertiser(1, 2000, account);
                    if (!Integer.valueOf(agentAccountList.get("code").toString()).equals(0)) {
                        log.info("代理商:{}拉取账户异常--{}", account, agentAccountList);
                    }
                    ;

                    JSONObject data = (JSONObject) agentAccountList.get("data");
                    //dataList.addAll((List) data.get("list"));
                    if (data.size() > 0) {
                        JSONObject page_info = (JSONObject) data.get("page_info");
                        int total_page = (int) page_info.get("total_page");
                        //查询其他页数据
                        for (int i = 0; i < total_page; i++) {
                            JSONObject agenttList = selectAgentAdvertiser(i + 1, 2000, account);
                            JSONObject agentData = (JSONObject) agenttList.get("data");
                            List<Long> list = (List<Long>) agentData.get("list");
                            list.stream().forEach(str -> {
                                dataList.add(str.toString());
                            });

                        }
                        log.info("拉取" + account + "下账户数量:{}", dataList.size());
                        //查询数据库已存在id
                        List<String> accountIdList = accountInfoService.getAllAccountId();
                        if (!accountIdList.isEmpty()) {
                            //筛选巨量引擎剔除的用户
                            List<String> removeList = accountIdList.stream().filter(item -> !dataList.contains(item)).collect(toList());
                            //筛选巨量引擎新增的用户
                            List<String> addList = dataList.stream().filter(item -> !accountIdList.contains(item)).collect(toList());
                            //修改剔除的用户状态
                            if (!removeList.isEmpty()) {
                                commonMapper.updateAgentAccountState(removeList, 1);
                            }
                            //保存新增的用户
                            if (!addList.isEmpty()) {
                                commonMapper.insertAccountData(addList, "73970348172", df.format(new Date()));
                            }
                        } else {
                            commonMapper.insertAccountData(dataList, "73970348172", df.format(new Date()));
                        }

                    }
                }
            }
        } catch (Exception e) {
            log.info("同步失败:{}", e.toString());
        }
    }

    /**
     * 获取账户列表
     *
     * @author zzy
     * @Param pageNum 当前页    pageSize 每页显示数量
     * @create: 2021-07-14
     */
    public JSONObject selectAgentAdvertiser(int pageNum, int pageSize, String account) {
        // 请求参数
        Map data = new HashMap() {
            {
                put("advertiser_id", account);
                put("page", pageNum);
                put("page_size", pageSize);
            }
        };
        return sendHttpRequest(data, "agent/advertiser/select/");
    }

    /**
     * 根据地址请求巨量殷勤，返回响应结果
     *
     * @author zzy
     * @Param data 请求参数    apiUrl请求路径
     * @create: 2021-07-14
     */
    public JSONObject sendHttpRequest(Map data, String apiUrl) {
        String access_token = getToken(Long.parseLong(data.get("advertiser_id").toString()));
        // 构造请求
        HttpEntityEnclosingRequestBase httpEntity = new HttpEntityEnclosingRequestBase() {
            @Override
            public String getMethod() {
                return "GET";
            }
        };

        httpEntity.setHeader("Access-Token", access_token);

        CloseableHttpResponse response = null;
        CloseableHttpClient client = null;

        try {
            client = HttpClientBuilder.create().build();
            httpEntity.setURI(URI.create("https://ad.oceanengine.com/open_api/2/" + apiUrl));
            httpEntity.setEntity(new StringEntity(JSONObject.toJSONString(data), ContentType.APPLICATION_JSON));

            response = client.execute(httpEntity);
            if (response != null && response.getStatusLine().getStatusCode() == 200) {
                BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(response.getEntity().getContent()));
                StringBuffer result = new StringBuffer();
                String line = "";
                while ((line = bufferedReader.readLine()) != null) {
                    result.append(line);
                }
                bufferedReader.close();
                return JSONObject.parseObject(result.toString());
            }

        } catch (ClientProtocolException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (response != null) {
                    response.close();
                }
                client.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return null;
    }

    /**
     * 获取token
     *
     * @author zzy
     * @create: 2021-07-14
     */
    public String getToken(long advertiserId) {
//        CtopOauthToken ctopOauthToken = ctopAgentAccountMapper.selectByAccountId(Long.parseLong(ADVERTISER_ID));
        CtopOauthToken ctopOauthToken = tokenService.getTokenByAccountId(advertiserId);
        if (ctopOauthToken != null) {
            return ctopOauthToken.getAccessToken();
        } else {
            log.info("未查询到Token");
            return null;
        }
    }


    /**
     * 同步账户日流水
     *
     * @author zzy
     * @create: 2021-07-15
     */
    @Override
    public void synchronousAccountTransactionDay(String startDate, String endDate) {
        log.info("开始同步账号日流水---日期{}---{}", startDate, endDate);
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");//设置日期格式
        Calendar ca = Calendar.getInstance();
        ca.setTime(new Date());
        ca.add(Calendar.DATE, -1);
        try {
            List<String> accountIdList = accountInfoService.getAllAccountId();
//            List<String> accountIdList = new ArrayList<>();
            //accountIdList.add("1744115510360071");
            if (!accountIdList.isEmpty()) {
                accountIdList.stream().forEach(str -> {
                    List<TransactionDay> transactionDetailsList = new ArrayList<>();
                    if (!str.isEmpty()) {
                        //查询账号下充值的交易流水
                        JSONObject jsonObject = queryAccountTransactionDay(str, 1, 1000, startDate, endDate);
                        JSONObject data = null;
                        int code = 1;
                        if (jsonObject != null) {
                            data = (JSONObject) jsonObject.get("data");
                            code = (int) jsonObject.get("code");
                        } else {
                            log.info("返回数据jsonObject为null:");
                        }
                        if (code != 0) {
                            log.info("返回数据:" + jsonObject.toJSONString() + ":" + str);
                        }
                        if (data != null) {
                            List<Object> dataList = (List<Object>) data.get("list");
                            if (dataList != null && !dataList.isEmpty()) {
                                //充值类存在记录
                                //保存第一页数据
                                dataList.stream().forEach(ob -> {
                                    TransactionDay transactionDay = JSONObject.toJavaObject((JSON) ob, TransactionDay.class);
                                    List<String> advertiserIdList = commonMapper.getAccountTransactionDayIdByDate(transactionDay.getDate(), transactionDay.getAdvertiserId());

                                    if (advertiserIdList.size() > 1) {
                                        commonMapper.deleteAccountTransactionById(advertiserIdList.get(0));
                                        log.info("----------->删除重复数据。accountId:{},date:{}", transactionDay.getAdvertiserId(), transactionDay.getDate());
                                    }
                                    //订单号不存在
                                    if (advertiserIdList.isEmpty() || advertiserIdList.size() <= 0) {
                                        transactionDetailsList.add(transactionDay);
                                    }

                                });
                                JSONObject page_info = (JSONObject) data.get("page_info");
                                int total_page = (int) page_info.get("total_page");
                                //查询其他页数据
                                if (total_page > 1) {
                                    for (int i = 2; i <= total_page; i++) {
                                        JSONObject jo = queryAccountTransactionDay(str, i, 1000, startDate, endDate);
                                        JSONObject accountData = (JSONObject) jo.get("data");
                                        List<Object> rechargeList = (List<Object>) accountData.get("list");
                                        rechargeList.stream().forEach(obj -> {
                                            TransactionDay transactionDay = JSONObject.toJavaObject((JSON) obj, TransactionDay.class);
                                            List<String> advertiserIdList = commonMapper.getAccountTransactionDayIdByDate(transactionDay.getDate(), transactionDay.getAdvertiserId());

                                            if (advertiserIdList.size() > 1) {
                                                commonMapper.deleteAccountTransactionById(advertiserIdList.get(0));
                                            }

                                            //订单号不存在
                                            if (advertiserIdList.isEmpty() || advertiserIdList.size() <= 0) {
                                                transactionDetailsList.add(transactionDay);
                                            }
                                        });
                                    }
                                }
                            }
                        }
                    }
                    //保存数据
                    if (!transactionDetailsList.isEmpty()) {
                        commonMapper.saveAccountTransactionDay(transactionDetailsList, df.format(new Date()));
                        log.info("新增日流水记录：{}条", transactionDetailsList.size());
                    }
                });
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.info("同步失败:{}", e.toString());
        }
    }

    /**
     * 查询账号日流水
     *
     * @return
     * @author zzy
     * @Param AccountId 账户id       pageNum 当前页    pageSize 每页显示数量
     * @create: 2021-07-14
     */
    public JSONObject queryAccountTransactionDay(String AccountId, int pageNum, int pageSize, String startDate, String endDate) {
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");//设置日期格式
        Calendar ca = Calendar.getInstance();
        ca.setTime(new Date());
        ca.add(Calendar.DATE, -1);
        // 请求参数
        Map data = new HashMap() {
            {
                put("advertiser_id", AccountId);
                put("start_date", startDate);
                put("end_date", endDate);
                put("page", pageNum);
                put("page_size", pageSize);
            }
        };
        return sendHttpRequest(data, "advertiser/fund/daily_stat/");
    }

    /**
     * 同步账户交易流水
     *
     * @author zzy
     * @create: 2021-07-15
     */
    @Override
    public void synchronousAccountTransactionDetails(String startDate, String endDate) {
        log.info("开始同步账号交易流水");
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");//设置日期格式
        List<TransactionDetails> transactionDetailsList = new ArrayList<>();
        try {
            List<String> accountIdList = accountInfoService.getAllAccountId();
            if (!accountIdList.isEmpty()) {
                List<String> transactionSeqList = commonMapper.getTransactionSeq(df.format(new Date()));
                accountIdList.stream().forEach(str -> {
                    if (!str.isEmpty()) {
                        //查询账号下充值的交易流水
                        JSONObject jsonObject = queryAccountTransactionDetails(str, "RECHARGE", 1, 1000, startDate, endDate);
                        int code = (int) jsonObject.get("code");
                        if (code != 0) {
                            log.info((String) jsonObject.get("message"));
                            return;
                        }
                        JSONObject data = (JSONObject) jsonObject.get("data");
                        if (data != null) {
                            List<Object> dataList = (List<Object>) data.get("list");
                            if (dataList != null && !dataList.isEmpty()) {
                                //充值类存在记录
                                //保存第一页数据
                                dataList.stream().forEach(ob -> {
                                    TransactionDetails transactionDetails = JSONObject.toJavaObject((JSON) ob, TransactionDetails.class);
                                    //订单号不存在
                                    if (transactionSeqList.isEmpty() || !transactionSeqList.contains(transactionDetails.getTransaction_seq())) {
                                        transactionDetailsList.add(transactionDetails);
                                    }

                                });
                                JSONObject page_info = (JSONObject) data.get("page_info");
                                int total_page = (int) page_info.get("total_page");
                                //查询其他页数据
                                if (total_page > 1) {
                                    for (int i = 2; i <= total_page; i++) {
                                        JSONObject jo = queryAccountTransactionDetails(str, "RECHARGE", i, 1000, startDate, endDate);
                                        JSONObject accountData = (JSONObject) jo.get("data");
                                        List<Object> rechargeList = (List<Object>) accountData.get("list");
                                        rechargeList.stream().forEach(transactionDetails -> {
                                            TransactionDetails transactionDetailsOther = JSONObject.toJavaObject((JSON) transactionDetails, TransactionDetails.class);
                                            //订单号不存在
                                            if (transactionSeqList.isEmpty() || !transactionSeqList.contains(transactionDetailsOther.getTransaction_seq())) {
                                                transactionDetailsList.add(transactionDetailsOther);
                                            }
                                        });
                                    }
                                }
                            }
                        }
                        //查询账号下转账的交易流水
                        JSONObject transferJsonObject = queryAccountTransactionDetails(str, "TRANSFER", 1, 1000, startDate, endDate);
                        JSONObject transferData = (JSONObject) transferJsonObject.get("data");
                        int code1 = (int) jsonObject.get("code");
                        if (code1 != 0) {
                            log.info((String) jsonObject.get("message"));
                            return;
                        }
                        if (transferData != null) {
                            List<Object> transferDataList = (List<Object>) transferData.get("list");
                            if (!transferDataList.isEmpty()) {
                                //转账类存在记录
                                //保存第一页数据
                                transferDataList.stream().forEach(ob -> {
                                    TransactionDetails transactionDetails = JSONObject.toJavaObject((JSON) ob, TransactionDetails.class);
                                    //订单号不存在
                                    if (transactionSeqList.isEmpty() || !transactionSeqList.contains(transactionDetails.getTransaction_seq())) {
                                        transactionDetailsList.add(transactionDetails);
                                    }
                                });
                                JSONObject transferPageInfo = (JSONObject) transferData.get("page_info");
                                int transferTotalPage = (int) transferPageInfo.get("total_page");
                                //查询其他页数据
                                if (transferTotalPage > 1) {
                                    for (int i = 2; i <= transferTotalPage; i++) {
                                        JSONObject jo = queryAccountTransactionDetails(str, "TRANSFER", i, 1000, startDate, endDate);
                                        JSONObject accountData = (JSONObject) jo.get("data");
                                        List<Object> rechargeList = (List<Object>) accountData.get("list");
                                        rechargeList.stream().forEach(transactionDetails -> {
                                            TransactionDetails transactionDetailsOther = JSONObject.toJavaObject((JSON) transactionDetails, TransactionDetails.class);
                                            //订单号不存在
                                            if (transactionSeqList.isEmpty() || !transactionSeqList.contains(transactionDetailsOther.getTransaction_seq())) {
                                                transactionDetailsList.add(transactionDetailsOther);
                                            }
                                        });
                                    }
                                }
                            }
                        }

                    }
                });
            }
            //保存数据
            if (!transactionDetailsList.isEmpty()) {
                commonMapper.saveAccountTransactionDetails(transactionDetailsList, df.format(new Date()));
                log.info("新增交易记录：{}条", transactionDetailsList.size());
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.info("同步失败:{}", e.toString());
        }
    }

    /**
     * 查询账号流水明细
     *
     * @return
     * @author zzy
     * @Param AccountId 账户id    transaction_type 流水类型  RECHARGE:充值  TRANSFER:转账     pageNum 当前页    pageSize 每页显示数量
     * @create: 2021-07-14
     */
    public JSONObject queryAccountTransactionDetails(String AccountId, String transaction_type, int pageNum, int pageSize, String startDate, String endDate) {
        // 请求参数
        Map data = new HashMap() {
            {
                put("advertiser_id", AccountId);
                put("start_date", startDate);
                put("end_date", endDate);
                put("transaction_type", transaction_type);
                put("page", pageNum);
                put("page_size", pageSize);
            }
        };
        return sendHttpRequest(data, "advertiser/fund/transaction/get/");
    }

    static ExecutorService executorService = Executors.newFixedThreadPool(3);

    @Override
    public void insertAccountTransactionDay(String startDate, String endDate) {
        List<String> accountIdList = accountInfoService.getAccountIdByMedia("1");
        if (!Check.isNull(accountIdList)) {
            accountIdList.forEach(accountId -> executorService.submit(() -> this.insertAccountTransactionDay(accountId, startDate, endDate, 1)));
        }
    }

    public void insertAccountTransactionDay(String accountId, String startDate, String endDate, Integer page) {
        try {
            JSONObject obj = queryAccountTransactionDay(accountId, page, 1000, startDate, endDate);
            if (!Check.isNull(obj) && obj.getInteger("code") == 0) {
                JSONObject data = obj.getJSONObject("data");
                JSONArray list = data.getJSONArray("list");
                List<TransactionDay> transactionDays = JSONArray.parseArray(list.toJSONString(), TransactionDay.class);
                if (!Check.isNull(transactionDays)) {
                    commonMapper.replaceAccountTransactionDay(transactionDays);
                }
                JSONObject pageInfo = data.getJSONObject("page_info");
                Integer totalPage = pageInfo.getInteger("total_page");
                if (totalPage > page) {
                    insertAccountTransactionDay(accountId, startDate, endDate, page + 1);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.info("同步失败:{}", e.toString());
        }
    }

    @Override
    public List<String> getMd5List() {
        return commonMapper.getMd5List();
    }

    @Override
    public void updateBySignature(String signature) {
        commonMapper.updateBySignature(signature);
    }

    @Override
    public List<String> getMaterialInfoCodeList(String date) {
        return commonMapper.getMaterialInfoCodeList(date);
    }

    @Override
    public Integer getMaterialInfoCountByCode(String code) {
        return commonMapper.getMaterialInfoCountByCode(code);
    }
    @Override
    public void updateMaterialInfoByCode(String code) {
        commonMapper.updateMaterialInfoByCode(code);
    }

    @Override
    public List<String> getBytedanceCodeList(String date) {
        return commonMapper.getBytedanceCodeList(date);
    }

    @Override
    public Integer getBytedanceCountByCode(String s) {
        return commonMapper.getBytedanceCountByCode(s);
    }

    @Override
    public void updateByteDanceByCode(String s) {
        commonMapper.updateByteDanceByCode(s);
    }

    @Override
    public List<Long> getAccountIds() {
        return commonMapper.getAccountIds();
    }

}

